/* xnoise-mpris.c generated by valac 0.18.1, the Vala compiler
 * generated from xnoise-mpris.vala, do not modify */

/* xnoise-mpris.vala
 *
 * Copyright (C) 2010 Andreas Obergrusberger
 * Copyright (C) 2010 - 2012 Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * Andreas Obergrusberger
 * Jörn Magens
 */
/* exposes xnoise's player and tracklist controls via dbus using the mpris v2 interface*/
/* refer to */
/* http://www.mpris.org/2.0/spec/*/

#include <glib.h>
#include <glib-object.h>
#include <xnoise-1.0.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>


#define XNOISE_TYPE_MPRIS (xnoise_mpris_get_type ())
#define XNOISE_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MPRIS, XnoiseMpris))
#define XNOISE_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MPRIS, XnoiseMprisClass))
#define XNOISE_IS_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MPRIS))
#define XNOISE_IS_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MPRIS))
#define XNOISE_MPRIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MPRIS, XnoiseMprisClass))

typedef struct _XnoiseMpris XnoiseMpris;
typedef struct _XnoiseMprisClass XnoiseMprisClass;
typedef struct _XnoiseMprisPrivate XnoiseMprisPrivate;

#define TYPE_MPRIS_PLAYER (mpris_player_get_type ())
#define MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_PLAYER, MprisPlayer))
#define MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_PLAYER, MprisPlayerClass))
#define IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_PLAYER))
#define IS_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_PLAYER))
#define MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_PLAYER, MprisPlayerClass))

typedef struct _MprisPlayer MprisPlayer;
typedef struct _MprisPlayerClass MprisPlayerClass;

#define TYPE_MPRIS_ROOT (mpris_root_get_type ())
#define MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_ROOT, MprisRoot))
#define MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_ROOT, MprisRootClass))
#define IS_MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_ROOT))
#define IS_MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_ROOT))
#define MPRIS_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_ROOT, MprisRootClass))

typedef struct _MprisRoot MprisRoot;
typedef struct _MprisRootClass MprisRootClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MprisRootPrivate MprisRootPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MprisPlayerPrivate MprisPlayerPrivate;

#define MPRIS_PLAYER_TYPE_DIRECTION (mpris_player_direction_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

#define TYPE_MPRIS_TRACK_LIST (mpris_track_list_get_type ())
#define MPRIS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_TRACK_LIST, MprisTrackList))
#define MPRIS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_TRACK_LIST, MprisTrackListClass))
#define IS_MPRIS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_TRACK_LIST))
#define IS_MPRIS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_TRACK_LIST))
#define MPRIS_TRACK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_TRACK_LIST, MprisTrackListClass))

typedef struct _MprisTrackList MprisTrackList;
typedef struct _MprisTrackListClass MprisTrackListClass;
typedef struct _MprisTrackListPrivate MprisTrackListPrivate;

struct _XnoiseMpris {
	GObject parent_instance;
	XnoiseMprisPrivate * priv;
	MprisPlayer* player;
	MprisRoot* root;
};

struct _XnoiseMprisClass {
	GObjectClass parent_class;
};

struct _XnoiseMprisPrivate {
	XnoiseMain* _xn;
	guint owner_id;
	guint object_id_root;
	guint object_id_player;
	guint object_id_tracklist;
	XnoisePluginModuleContainer* _owner;
	GDBusConnection* conn;
};

struct _MprisRoot {
	GObject parent_instance;
	MprisRootPrivate * priv;
};

struct _MprisRootClass {
	GObjectClass parent_class;
};

struct _MprisRootPrivate {
	XnoiseMain* xn;
};

struct _MprisPlayer {
	GObject parent_instance;
	MprisPlayerPrivate * priv;
};

struct _MprisPlayerClass {
	GObjectClass parent_class;
};

struct _MprisPlayerPrivate {
	XnoiseMain* xn;
	GDBusConnection* conn;
	guint send_property_source;
	guint update_metadata_source;
	GHashTable* changed_properties;
	XnoiseMainWindowPlayerRepeatMode buffer_repeat_state;
	GHashTable* _metadata;
	gboolean _CanSeek;
};

typedef enum  {
	MPRIS_PLAYER_DIRECTION_NEXT = 0,
	MPRIS_PLAYER_DIRECTION_PREVIOUS,
	MPRIS_PLAYER_DIRECTION_STOP
} MprisPlayerDirection;

struct _Block1Data {
	int _ref_count_;
	MprisPlayer * self;
	gint64 Position;
};

struct _MprisTrackList {
	GObject parent_instance;
	MprisTrackListPrivate * priv;
};

struct _MprisTrackListClass {
	GObjectClass parent_class;
};

struct _MprisTrackListPrivate {
	XnoiseMain* xn;
	GDBusConnection* conn;
};


static gpointer xnoise_mpris_parent_class = NULL;
static XnoisePluginModuleIPluginIface* xnoise_mpris_xnoise_plugin_module_iplugin_parent_iface = NULL;
static GType xnoise_mpris_type_id = 0;
static gpointer mpris_root_parent_class = NULL;
static GType mpris_root_type_id = 0;
static gpointer mpris_player_parent_class = NULL;
static GType mpris_player_type_id = 0;
static gpointer mpris_track_list_parent_class = NULL;
static GType mpris_track_list_type_id = 0;

GType xnoise_mpris_get_type (void) G_GNUC_CONST;
GType xnoise_mpris_register_type (GTypeModule * module);
GType mpris_player_get_type (void) G_GNUC_CONST;
GType mpris_player_register_type (GTypeModule * module);
guint mpris_player_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType mpris_root_get_type (void) G_GNUC_CONST;
GType mpris_root_register_type (GTypeModule * module);
guint mpris_root_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
#define XNOISE_MPRIS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MPRIS, XnoiseMprisPrivate))
enum  {
	XNOISE_MPRIS_DUMMY_PROPERTY,
	XNOISE_MPRIS_XN,
	XNOISE_MPRIS_OWNER,
	XNOISE_MPRIS_NAME
};
static void xnoise_mpris_on_bus_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name);
MprisRoot* mpris_root_new (void);
MprisRoot* mpris_root_construct (GType object_type);
MprisPlayer* mpris_player_new (GDBusConnection* conn);
MprisPlayer* mpris_player_construct (GType object_type, GDBusConnection* conn);
static void xnoise_mpris_on_name_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name);
static void xnoise_mpris_on_name_lost (XnoiseMpris* self, GDBusConnection* connection, const gchar* name);
static gboolean xnoise_mpris_real_init (XnoisePluginModuleIPlugin* base);
static void _xnoise_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void _xnoise_mpris_on_name_lost_gbus_name_lost_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void xnoise_mpris_clean_up (XnoiseMpris* self);
static void _xnoise_mpris_clean_up_xnoise_plugin_module_container_sign_deactivated (XnoisePluginModuleContainer* _sender, gpointer self);
static void xnoise_mpris_real_uninit (XnoisePluginModuleIPlugin* base);
static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoisePluginModuleIPlugin* base);
static gboolean xnoise_mpris_real_has_settings_widget (XnoisePluginModuleIPlugin* base);
XnoiseMpris* xnoise_mpris_new (void);
XnoiseMpris* xnoise_mpris_construct (GType object_type);
static void xnoise_mpris_finalize (GObject* obj);
static void _vala_xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define MPRIS_ROOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_ROOT, MprisRootPrivate))
enum  {
	MPRIS_ROOT_DUMMY_PROPERTY,
	MPRIS_ROOT_CAN_QUIT,
	MPRIS_ROOT_CAN_RAISE,
	MPRIS_ROOT_HAS_TRACK_LIST,
	MPRIS_ROOT_DESKTOP_ENTRY,
	MPRIS_ROOT_IDENTITY,
	MPRIS_ROOT_SUPPORTED_URI_SCHEMES,
	MPRIS_ROOT_SUPPORTED_MIME_TYPES
};
void mpris_root_Quit (MprisRoot* self);
void mpris_root_Raise (MprisRoot* self);
gboolean mpris_root_get_CanQuit (MprisRoot* self);
gboolean mpris_root_get_CanRaise (MprisRoot* self);
gboolean mpris_root_get_HasTrackList (MprisRoot* self);
gchar* mpris_root_get_DesktopEntry (MprisRoot* self);
gchar* mpris_root_get_Identity (MprisRoot* self);
gchar** mpris_root_get_SupportedUriSchemes (MprisRoot* self, int* result_length1);
gchar** mpris_root_get_SupportedMimeTypes (MprisRoot* self, int* result_length1);
static void mpris_root_finalize (GObject* obj);
static void _vala_mpris_root_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _dbus_mpris_root_Quit (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_root_Raise (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_root_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_root_get_CanQuit (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_CanRaise (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_HasTrackList (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_DesktopEntry (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_Identity (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_SupportedUriSchemes (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_SupportedMimeTypes (MprisRoot* self);
static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _mpris_root_unregister_object (gpointer user_data);
#define MPRIS_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_PLAYER, MprisPlayerPrivate))
enum  {
	MPRIS_PLAYER_DUMMY_PROPERTY,
	MPRIS_PLAYER_PLAYBACK_STATUS,
	MPRIS_PLAYER_LOOP_STATUS,
	MPRIS_PLAYER_RATE,
	MPRIS_PLAYER_SHUFFLE,
	MPRIS_PLAYER_METADATA,
	MPRIS_PLAYER_VOLUME,
	MPRIS_PLAYER_POSITION,
	MPRIS_PLAYER_MINIMUM_RATE,
	MPRIS_PLAYER_MAXIMUM_RATE,
	MPRIS_PLAYER_CAN_GO_NEXT,
	MPRIS_PLAYER_CAN_GO_PREVIOUS,
	MPRIS_PLAYER_CAN_PLAY,
	MPRIS_PLAYER_CAN_PAUSE,
	MPRIS_PLAYER_CAN_SEEK,
	MPRIS_PLAYER_CAN_CONTROL
};
static GType mpris_player_direction_get_type (void) G_GNUC_UNUSED;
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
#define MPRIS_PLAYER_INTERFACE_NAME "org.mpris.MediaPlayer2.Player"
static void __lambda2_ (MprisPlayer* self, GObject* s, GParamSpec* p);
gchar* mpris_player_get_PlaybackStatus (MprisPlayer* self);
static GVariant* _variant_new1 (gchar* value);
static void mpris_player_queue_property_for_notification (MprisPlayer* self, const gchar* property, GVariant* val);
static void ___lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void mpris_player_on_tag_changed (MprisPlayer* self, XnoiseGlobalAccess* sender, const gchar* newuri, const gchar* tagname, const gchar* tagvalue);
static void _mpris_player_on_tag_changed_xnoise_global_access_tag_changed (XnoiseGlobalAccess* _sender, const gchar* newuri, const gchar* tagname, const gchar* tagvalue, gpointer self);
static void __lambda4_ (MprisPlayer* self);
static GVariant* _variant_new2 (gdouble value);
static void ___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void __lambda5_ (MprisPlayer* self);
static GVariant* _variant_new3 (const gchar* value);
static GVariant* _variant_new4 (gchar* value);
static GVariant* _variant_new5 (const gchar* value);
static void mpris_player_trigger_metadata_update (MprisPlayer* self);
static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void __lambda6_ (MprisPlayer* self);
static GVariant* _variant_new6 (gint64 value);
static gint64 _variant_get7 (GVariant* value);
static GVariant* _variant_new8 (gint64 value);
static void ___lambda6__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void __lambda7_ (MprisPlayer* self, XnoiseGstPlayer* g, guint p, guint s);
static void ___lambda7__xnoise_gst_player_sign_position_changed (XnoiseGstPlayer* _sender, guint msecs, guint ms_total, gpointer self);
static gboolean __lambda3_ (MprisPlayer* self);
static GVariant* _variant_new9 (GHashTable* value);
static gboolean ___lambda3__gsource_func (gpointer self);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
static GVariant* _variant_new10 (gchar** value, gint value_length1);
static GVariant* _variant_new11 (const gchar* value);
static GVariant* _variant_new12 (const gchar* value);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
static GVariant* _variant_new13 (gchar** value, gint value_length1);
static gboolean mpris_player_send_property_change (MprisPlayer* self);
static gboolean _mpris_player_send_property_change_gsource_func (gpointer self);
void mpris_player_Next (MprisPlayer* self);
void mpris_player_Previous (MprisPlayer* self);
void mpris_player_Pause (MprisPlayer* self);
void mpris_player_PlayPause (MprisPlayer* self);
void mpris_player_Stop (MprisPlayer* self);
void mpris_player_Play (MprisPlayer* self);
void mpris_player_Seek (MprisPlayer* self, gint64 offset);
static gboolean __lambda8_ (MprisPlayer* self);
static gboolean ___lambda8__gsource_func (gpointer self);
void mpris_player_SetPosition (MprisPlayer* self, const char* TrackId, gint64 Position);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda9_ (Block1Data* _data1_);
static gboolean __lambda10_ (Block1Data* _data1_);
static gboolean ___lambda10__gsource_func (gpointer self);
static gboolean ___lambda9__gsource_func (gpointer self);
void mpris_player_OpenUri (MprisPlayer* self, const gchar* Uri);
gchar* mpris_player_get_LoopStatus (MprisPlayer* self);
void mpris_player_set_LoopStatus (MprisPlayer* self, const gchar* value);
static GVariant* _variant_new14 (const gchar* value);
gdouble mpris_player_get_Rate (MprisPlayer* self);
void mpris_player_set_Rate (MprisPlayer* self, gdouble value);
gboolean mpris_player_get_Shuffle (MprisPlayer* self);
void mpris_player_set_Shuffle (MprisPlayer* self, gboolean value);
static GVariant* _variant_new15 (gboolean value);
GHashTable* mpris_player_get_Metadata (MprisPlayer* self);
static GVariant* _variant_new16 (const gchar* value);
gdouble mpris_player_get_Volume (MprisPlayer* self);
void mpris_player_set_Volume (MprisPlayer* self, gdouble value);
gint64 mpris_player_get_Position (MprisPlayer* self);
gdouble mpris_player_get_MinimumRate (MprisPlayer* self);
gdouble mpris_player_get_MaximumRate (MprisPlayer* self);
gboolean mpris_player_get_CanGoNext (MprisPlayer* self);
gboolean mpris_player_get_CanGoPrevious (MprisPlayer* self);
gboolean mpris_player_get_CanPlay (MprisPlayer* self);
gboolean mpris_player_get_CanPause (MprisPlayer* self);
gboolean mpris_player_get_CanSeek (MprisPlayer* self);
gboolean mpris_player_get_CanControl (MprisPlayer* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void mpris_player_finalize (GObject* obj);
static void _vala_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _dbus_mpris_player_Next (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Previous (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Pause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_PlayPause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Stop (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Play (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Seek (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_SetPosition (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_OpenUri (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_player_get_PlaybackStatus (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_LoopStatus (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Rate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Shuffle (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Metadata (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Volume (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Position (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_MinimumRate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_MaximumRate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanGoNext (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanGoPrevious (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanPlay (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanPause (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanSeek (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanControl (MprisPlayer* self);
static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_mpris_player_set_LoopStatus (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Rate (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Shuffle (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Volume (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_seeked (GObject* _sender, gint64 Position, gpointer* _data);
static void _mpris_player_unregister_object (gpointer user_data);
GType mpris_track_list_get_type (void) G_GNUC_CONST;
GType mpris_track_list_register_type (GTypeModule * module);
guint mpris_track_list_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
#define MPRIS_TRACK_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_TRACK_LIST, MprisTrackListPrivate))
enum  {
	MPRIS_TRACK_LIST_DUMMY_PROPERTY
};
MprisTrackList* mpris_track_list_new (GDBusConnection* conn);
MprisTrackList* mpris_track_list_construct (GType object_type, GDBusConnection* conn);
GHashTable* mpris_track_list_GetTracksMetadata (MprisTrackList* self, gint Position);
gint mpris_track_list_AddTrack (MprisTrackList* self, const gchar* Uri, gboolean PlayImmediately);
gint mpris_track_list_GetCurrentTrack (MprisTrackList* self);
gint mpris_track_list_GetLength (MprisTrackList* self);
void mpris_track_list_DelTrack (MprisTrackList* self, gint Position);
void mpris_track_list_SetLoop (MprisTrackList* self, gboolean State);
void mpris_track_list_SetRandom (MprisTrackList* self, gboolean State);
static void mpris_track_list_finalize (GObject* obj);
static void _dbus_mpris_track_list_GetTracksMetadata (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_track_list_AddTrack (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_track_list_GetCurrentTrack (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_track_list_GetLength (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_track_list_DelTrack (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_track_list_SetLoop (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_track_list_SetRandom (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_track_list_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_track_list_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean mpris_track_list_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_mpris_track_list_track_list_change (GObject* _sender, gint Nb_Tracks, gpointer* _data);
static void _mpris_track_list_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Quit_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Quit_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_Quit = {-1, "Quit", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Quit_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Quit_out)};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Raise_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Raise_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_Raise = {-1, "Raise", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Raise_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Raise_out)};
static const GDBusMethodInfo * const _mpris_root_dbus_method_info[] = {&_mpris_root_dbus_method_info_Quit, &_mpris_root_dbus_method_info_Raise, NULL};
static const GDBusSignalInfo * const _mpris_root_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_CanQuit = {-1, "CanQuit", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_CanRaise = {-1, "CanRaise", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_HasTrackList = {-1, "HasTrackList", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_DesktopEntry = {-1, "DesktopEntry", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_Identity = {-1, "Identity", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_SupportedUriSchemes = {-1, "SupportedUriSchemes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_SupportedMimeTypes = {-1, "SupportedMimeTypes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _mpris_root_dbus_property_info[] = {&_mpris_root_dbus_property_info_CanQuit, &_mpris_root_dbus_property_info_CanRaise, &_mpris_root_dbus_property_info_HasTrackList, &_mpris_root_dbus_property_info_DesktopEntry, &_mpris_root_dbus_property_info_Identity, &_mpris_root_dbus_property_info_SupportedUriSchemes, &_mpris_root_dbus_property_info_SupportedMimeTypes, NULL};
static const GDBusInterfaceInfo _mpris_root_dbus_interface_info = {-1, "org.mpris.MediaPlayer2", (GDBusMethodInfo **) (&_mpris_root_dbus_method_info), (GDBusSignalInfo **) (&_mpris_root_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_root_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_root_dbus_interface_vtable = {mpris_root_dbus_interface_method_call, mpris_root_dbus_interface_get_property, mpris_root_dbus_interface_set_property};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Next_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Next_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Next = {-1, "Next", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Next_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Next_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Previous_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Previous_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Previous = {-1, "Previous", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Previous_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Previous_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Pause = {-1, "Pause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Pause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_PlayPause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_PlayPause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_PlayPause = {-1, "PlayPause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_PlayPause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_PlayPause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Stop_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Stop_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Stop = {-1, "Stop", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Stop_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Stop_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Play_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Play_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Play = {-1, "Play", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Play_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Play_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_Seek_offset = {-1, "offset", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Seek_in[] = {&_mpris_player_dbus_arg_info_Seek_offset, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Seek_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Seek = {-1, "Seek", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Seek_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Seek_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_SetPosition_TrackId = {-1, "TrackId", "o"};
static const GDBusArgInfo _mpris_player_dbus_arg_info_SetPosition_Position = {-1, "Position", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_SetPosition_in[] = {&_mpris_player_dbus_arg_info_SetPosition_TrackId, &_mpris_player_dbus_arg_info_SetPosition_Position, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_SetPosition_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_SetPosition = {-1, "SetPosition", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_SetPosition_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_SetPosition_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_OpenUri_Uri = {-1, "Uri", "s"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_OpenUri_in[] = {&_mpris_player_dbus_arg_info_OpenUri_Uri, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_OpenUri_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_OpenUri = {-1, "OpenUri", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_OpenUri_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_OpenUri_out)};
static const GDBusMethodInfo * const _mpris_player_dbus_method_info[] = {&_mpris_player_dbus_method_info_Next, &_mpris_player_dbus_method_info_Previous, &_mpris_player_dbus_method_info_Pause, &_mpris_player_dbus_method_info_PlayPause, &_mpris_player_dbus_method_info_Stop, &_mpris_player_dbus_method_info_Play, &_mpris_player_dbus_method_info_Seek, &_mpris_player_dbus_method_info_SetPosition, &_mpris_player_dbus_method_info_OpenUri, NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_seeked_Position = {-1, "Position", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_seeked[] = {&_mpris_player_dbus_arg_info_seeked_Position, NULL};
static const GDBusSignalInfo _mpris_player_dbus_signal_info_seeked = {-1, "Seeked", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_seeked)};
static const GDBusSignalInfo * const _mpris_player_dbus_signal_info[] = {&_mpris_player_dbus_signal_info_seeked, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_PlaybackStatus = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_LoopStatus = {-1, "LoopStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Rate = {-1, "Rate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Shuffle = {-1, "Shuffle", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Volume = {-1, "Volume", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Position = {-1, "Position", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_MinimumRate = {-1, "MinimumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_MaximumRate = {-1, "MaximumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanGoNext = {-1, "CanGoNext", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanGoPrevious = {-1, "CanGoPrevious", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanPlay = {-1, "CanPlay", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanPause = {-1, "CanPause", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanSeek = {-1, "CanSeek", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanControl = {-1, "CanControl", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _mpris_player_dbus_property_info[] = {&_mpris_player_dbus_property_info_PlaybackStatus, &_mpris_player_dbus_property_info_LoopStatus, &_mpris_player_dbus_property_info_Rate, &_mpris_player_dbus_property_info_Shuffle, &_mpris_player_dbus_property_info_Metadata, &_mpris_player_dbus_property_info_Volume, &_mpris_player_dbus_property_info_Position, &_mpris_player_dbus_property_info_MinimumRate, &_mpris_player_dbus_property_info_MaximumRate, &_mpris_player_dbus_property_info_CanGoNext, &_mpris_player_dbus_property_info_CanGoPrevious, &_mpris_player_dbus_property_info_CanPlay, &_mpris_player_dbus_property_info_CanPause, &_mpris_player_dbus_property_info_CanSeek, &_mpris_player_dbus_property_info_CanControl, NULL};
static const GDBusInterfaceInfo _mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_player_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_player_dbus_interface_vtable = {mpris_player_dbus_interface_method_call, mpris_player_dbus_interface_get_property, mpris_player_dbus_interface_set_property};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_GetTracksMetadata_Position = {-1, "Position", "i"};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_GetTracksMetadata_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_GetTracksMetadata_in[] = {&_mpris_track_list_dbus_arg_info_GetTracksMetadata_Position, NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_GetTracksMetadata_out[] = {&_mpris_track_list_dbus_arg_info_GetTracksMetadata_result, NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_GetTracksMetadata = {-1, "GetTracksMetadata", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_GetTracksMetadata_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_GetTracksMetadata_out)};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_AddTrack_Uri = {-1, "Uri", "s"};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_AddTrack_PlayImmediately = {-1, "PlayImmediately", "b"};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_AddTrack_result = {-1, "result", "i"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_AddTrack_in[] = {&_mpris_track_list_dbus_arg_info_AddTrack_Uri, &_mpris_track_list_dbus_arg_info_AddTrack_PlayImmediately, NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_AddTrack_out[] = {&_mpris_track_list_dbus_arg_info_AddTrack_result, NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_AddTrack = {-1, "AddTrack", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_AddTrack_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_AddTrack_out)};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_GetCurrentTrack_result = {-1, "result", "i"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_GetCurrentTrack_in[] = {NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_GetCurrentTrack_out[] = {&_mpris_track_list_dbus_arg_info_GetCurrentTrack_result, NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_GetCurrentTrack = {-1, "GetCurrentTrack", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_GetCurrentTrack_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_GetCurrentTrack_out)};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_GetLength_result = {-1, "result", "i"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_GetLength_in[] = {NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_GetLength_out[] = {&_mpris_track_list_dbus_arg_info_GetLength_result, NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_GetLength = {-1, "GetLength", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_GetLength_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_GetLength_out)};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_DelTrack_Position = {-1, "Position", "i"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_DelTrack_in[] = {&_mpris_track_list_dbus_arg_info_DelTrack_Position, NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_DelTrack_out[] = {NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_DelTrack = {-1, "DelTrack", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_DelTrack_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_DelTrack_out)};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_SetLoop_State = {-1, "State", "b"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_SetLoop_in[] = {&_mpris_track_list_dbus_arg_info_SetLoop_State, NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_SetLoop_out[] = {NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_SetLoop = {-1, "SetLoop", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_SetLoop_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_SetLoop_out)};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_SetRandom_State = {-1, "State", "b"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_SetRandom_in[] = {&_mpris_track_list_dbus_arg_info_SetRandom_State, NULL};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_SetRandom_out[] = {NULL};
static const GDBusMethodInfo _mpris_track_list_dbus_method_info_SetRandom = {-1, "SetRandom", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_SetRandom_in), (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_SetRandom_out)};
static const GDBusMethodInfo * const _mpris_track_list_dbus_method_info[] = {&_mpris_track_list_dbus_method_info_GetTracksMetadata, &_mpris_track_list_dbus_method_info_AddTrack, &_mpris_track_list_dbus_method_info_GetCurrentTrack, &_mpris_track_list_dbus_method_info_GetLength, &_mpris_track_list_dbus_method_info_DelTrack, &_mpris_track_list_dbus_method_info_SetLoop, &_mpris_track_list_dbus_method_info_SetRandom, NULL};
static const GDBusArgInfo _mpris_track_list_dbus_arg_info_track_list_change_Nb_Tracks = {-1, "Nb_Tracks", "i"};
static const GDBusArgInfo * const _mpris_track_list_dbus_arg_info_track_list_change[] = {&_mpris_track_list_dbus_arg_info_track_list_change_Nb_Tracks, NULL};
static const GDBusSignalInfo _mpris_track_list_dbus_signal_info_track_list_change = {-1, "TrackListChange", (GDBusArgInfo **) (&_mpris_track_list_dbus_arg_info_track_list_change)};
static const GDBusSignalInfo * const _mpris_track_list_dbus_signal_info[] = {&_mpris_track_list_dbus_signal_info_track_list_change, NULL};
static const GDBusPropertyInfo * const _mpris_track_list_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _mpris_track_list_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Tracklist", (GDBusMethodInfo **) (&_mpris_track_list_dbus_method_info), (GDBusSignalInfo **) (&_mpris_track_list_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_track_list_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_track_list_dbus_interface_vtable = {mpris_track_list_dbus_interface_method_call, mpris_track_list_dbus_interface_get_property, mpris_track_list_dbus_interface_set_property};

static void xnoise_mpris_on_bus_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name) {
	GDBusConnection* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = connection;
	self->priv->conn = _tmp0_;
	{
		MprisRoot* _tmp1_;
		GDBusConnection* _tmp2_;
		MprisRoot* _tmp3_;
		guint _tmp4_ = 0U;
		guint _tmp5_;
		GDBusConnection* _tmp6_;
		MprisPlayer* _tmp7_;
		GDBusConnection* _tmp8_;
		MprisPlayer* _tmp9_;
		guint _tmp10_ = 0U;
		guint _tmp11_;
		_tmp1_ = mpris_root_new ();
		_g_object_unref0 (self->root);
		self->root = _tmp1_;
		_tmp2_ = connection;
		_tmp3_ = self->root;
		_tmp4_ = mpris_root_register_object (_tmp3_, _tmp2_, "/org/mpris/MediaPlayer2", &_inner_error_);
		_tmp5_ = _tmp4_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->object_id_root = _tmp5_;
		_tmp6_ = connection;
		_tmp7_ = mpris_player_new (_tmp6_);
		_g_object_unref0 (self->player);
		self->player = _tmp7_;
		_tmp8_ = connection;
		_tmp9_ = self->player;
		_tmp10_ = mpris_player_register_object (_tmp9_, _tmp8_, "/org/mpris/MediaPlayer2", &_inner_error_);
		_tmp11_ = _tmp10_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->object_id_player = _tmp11_;
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = e;
		_tmp13_ = _tmp12_->message;
		g_print ("%s\n", _tmp13_);
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void xnoise_mpris_on_name_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}


static void xnoise_mpris_on_name_lost (XnoiseMpris* self, GDBusConnection* connection, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
	g_print ("name_lost\n");
}


static void _xnoise_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_mpris_on_bus_acquired (self, connection, name);
}


static void _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_mpris_on_name_acquired (self, connection, name);
}


static void _xnoise_mpris_on_name_lost_gbus_name_lost_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_mpris_on_name_lost (self, connection, name);
}


static void _xnoise_mpris_clean_up_xnoise_plugin_module_container_sign_deactivated (XnoisePluginModuleContainer* _sender, gpointer self) {
	xnoise_mpris_clean_up (self);
}


static gboolean xnoise_mpris_real_init (XnoisePluginModuleIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	guint _tmp0_ = 0U;
	guint _tmp1_;
	XnoisePluginModuleContainer* _tmp2_;
	XnoisePluginModuleContainer* _tmp3_;
	self = (XnoiseMpris*) base;
	_tmp0_ = g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.mpris.MediaPlayer2.xnoise", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((_xnoise_mpris_on_bus_acquired_gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_mpris_on_bus_acquired_gbus_acquired_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_xnoise_mpris_on_name_acquired_gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_xnoise_mpris_on_name_lost_gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_mpris_on_name_lost_gbus_name_lost_callback, g_object_ref (self), g_object_unref)));
	self->priv->owner_id = _tmp0_;
	_tmp1_ = self->priv->owner_id;
	if (_tmp1_ == ((guint) 0)) {
		g_print ("mpris error\n");
		result = FALSE;
		return result;
	}
	_tmp2_ = xnoise_plugin_module_iplugin_get_owner ((XnoisePluginModuleIPlugin*) self);
	_tmp3_ = _tmp2_;
	g_signal_connect_object (_tmp3_, "sign-deactivated", (GCallback) _xnoise_mpris_clean_up_xnoise_plugin_module_container_sign_deactivated, self, 0);
	result = TRUE;
	return result;
}


static void xnoise_mpris_real_uninit (XnoisePluginModuleIPlugin* base) {
	XnoiseMpris * self;
	self = (XnoiseMpris*) base;
	xnoise_mpris_clean_up (self);
}


static void xnoise_mpris_clean_up (XnoiseMpris* self) {
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->owner_id;
	if (_tmp0_ == ((guint) 0)) {
		return;
	}
	_tmp1_ = self->priv->owner_id;
	g_bus_unown_name (_tmp1_);
	self->priv->object_id_player = (guint) 0;
	self->priv->object_id_tracklist = (guint) 0;
	self->priv->object_id_root = (guint) 0;
	self->priv->owner_id = (guint) 0;
}


static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoisePluginModuleIPlugin* base) {
	XnoiseMpris * self;
	GtkWidget* result = NULL;
	self = (XnoiseMpris*) base;
	result = NULL;
	return result;
}


static gboolean xnoise_mpris_real_has_settings_widget (XnoisePluginModuleIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	self = (XnoiseMpris*) base;
	result = FALSE;
	return result;
}


XnoiseMpris* xnoise_mpris_construct (GType object_type) {
	XnoiseMpris * self = NULL;
	self = (XnoiseMpris*) g_object_new (object_type, NULL);
	return self;
}


XnoiseMpris* xnoise_mpris_new (void) {
	return xnoise_mpris_construct (XNOISE_TYPE_MPRIS);
}


static XnoiseMain* xnoise_mpris_real_get_xn (XnoisePluginModuleIPlugin* base) {
	XnoiseMain* result;
	XnoiseMpris* self;
	XnoiseMain* _tmp0_;
	self = (XnoiseMpris*) base;
	_tmp0_ = self->priv->_xn;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_mpris_real_set_xn (XnoisePluginModuleIPlugin* base, XnoiseMain* value) {
	XnoiseMpris* self;
	XnoiseMain* _tmp0_;
	XnoiseMain* _tmp1_;
	self = (XnoiseMpris*) base;
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_xn);
	self->priv->_xn = _tmp1_;
	g_object_notify ((GObject *) self, "xn");
}


static XnoisePluginModuleContainer* xnoise_mpris_real_get_owner (XnoisePluginModuleIPlugin* base) {
	XnoisePluginModuleContainer* result;
	XnoiseMpris* self;
	XnoisePluginModuleContainer* _tmp0_;
	self = (XnoiseMpris*) base;
	_tmp0_ = self->priv->_owner;
	result = _tmp0_;
	return result;
}


static void xnoise_mpris_real_set_owner (XnoisePluginModuleIPlugin* base, XnoisePluginModuleContainer* value) {
	XnoiseMpris* self;
	XnoisePluginModuleContainer* _tmp0_;
	self = (XnoiseMpris*) base;
	_tmp0_ = value;
	self->priv->_owner = _tmp0_;
	g_object_notify ((GObject *) self, "owner");
}


static const gchar* xnoise_mpris_real_get_name (XnoisePluginModuleIPlugin* base) {
	const gchar* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = "mpris";
	return result;
}


static void xnoise_mpris_class_init (XnoiseMprisClass * klass) {
	xnoise_mpris_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMprisPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_xnoise_mpris_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_xnoise_mpris_set_property;
	G_OBJECT_CLASS (klass)->finalize = xnoise_mpris_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_XN, g_param_spec_object ("xn", "xn", "xn", XNOISE_TYPE_MAIN, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_OWNER, g_param_spec_object ("owner", "owner", "owner", XNOISE_PLUGIN_MODULE_TYPE_CONTAINER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void xnoise_mpris_xnoise_plugin_module_iplugin_interface_init (XnoisePluginModuleIPluginIface * iface) {
	xnoise_mpris_xnoise_plugin_module_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = (gboolean (*)(XnoisePluginModuleIPlugin*)) xnoise_mpris_real_init;
	iface->uninit = (void (*)(XnoisePluginModuleIPlugin*)) xnoise_mpris_real_uninit;
	iface->get_settings_widget = (GtkWidget* (*)(XnoisePluginModuleIPlugin*)) xnoise_mpris_real_get_settings_widget;
	iface->has_settings_widget = (gboolean (*)(XnoisePluginModuleIPlugin*)) xnoise_mpris_real_has_settings_widget;
	iface->get_xn = xnoise_mpris_real_get_xn;
	iface->set_xn = xnoise_mpris_real_set_xn;
	iface->get_owner = xnoise_mpris_real_get_owner;
	iface->set_owner = xnoise_mpris_real_set_owner;
	iface->get_name = xnoise_mpris_real_get_name;
}


static void xnoise_mpris_instance_init (XnoiseMpris * self) {
	self->priv = XNOISE_MPRIS_GET_PRIVATE (self);
	self->player = NULL;
	self->root = NULL;
}


static void xnoise_mpris_finalize (GObject* obj) {
	XnoiseMpris * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TYPE_MPRIS, XnoiseMpris);
	_g_object_unref0 (self->priv->_xn);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->root);
	G_OBJECT_CLASS (xnoise_mpris_parent_class)->finalize (obj);
}


GType xnoise_mpris_get_type (void) {
	return xnoise_mpris_type_id;
}


GType xnoise_mpris_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMprisClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mpris_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMpris), 0, (GInstanceInitFunc) xnoise_mpris_instance_init, NULL };
	static const GInterfaceInfo xnoise_plugin_module_iplugin_info = { (GInterfaceInitFunc) xnoise_mpris_xnoise_plugin_module_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_mpris_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMpris", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_mpris_type_id, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, &xnoise_plugin_module_iplugin_info);
	return xnoise_mpris_type_id;
}


static void _vala_xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNOISE_TYPE_MPRIS, XnoiseMpris);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		g_value_set_object (value, xnoise_plugin_module_iplugin_get_xn ((XnoisePluginModuleIPlugin*) self));
		break;
		case XNOISE_MPRIS_OWNER:
		g_value_set_object (value, xnoise_plugin_module_iplugin_get_owner ((XnoisePluginModuleIPlugin*) self));
		break;
		case XNOISE_MPRIS_NAME:
		g_value_set_string (value, xnoise_plugin_module_iplugin_get_name ((XnoisePluginModuleIPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNOISE_TYPE_MPRIS, XnoiseMpris);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		xnoise_plugin_module_iplugin_set_xn ((XnoisePluginModuleIPlugin*) self, g_value_get_object (value));
		break;
		case XNOISE_MPRIS_OWNER:
		xnoise_plugin_module_iplugin_set_owner ((XnoisePluginModuleIPlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


MprisRoot* mpris_root_construct (GType object_type) {
	MprisRoot * self = NULL;
	XnoiseMain* _tmp0_;
	XnoiseMain* _tmp1_;
	self = (MprisRoot*) g_object_new (object_type, NULL);
	_tmp0_ = xnoise_main_get_instance ();
	_tmp1_ = _tmp0_;
	self->priv->xn = _tmp1_;
	return self;
}


MprisRoot* mpris_root_new (void) {
	return mpris_root_construct (TYPE_MPRIS_ROOT);
}


void mpris_root_Quit (MprisRoot* self) {
	XnoiseMain* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->xn;
	xnoise_main_quit (_tmp0_);
}


void mpris_root_Raise (MprisRoot* self) {
	XnoiseMainWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_main_window;
	xnoise_main_window_show_window (_tmp0_);
}


gboolean mpris_root_get_CanQuit (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_root_get_CanRaise (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_root_get_HasTrackList (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = FALSE;
	return result;
}


gchar* mpris_root_get_DesktopEntry (MprisRoot* self) {
	gchar* result;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("xnoise");
	result = _tmp0_;
	return result;
}


gchar* mpris_root_get_Identity (MprisRoot* self) {
	gchar* result;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("xnoise media player");
	result = _tmp0_;
	return result;
}


gchar** mpris_root_get_SupportedUriSchemes (MprisRoot* self, int* result_length1) {
	gchar** result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_ = NULL;
	gchar** sa;
	gint sa_length1;
	gint _sa_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("http");
	_tmp1_ = g_strdup ("file");
	_tmp2_ = g_strdup ("https");
	_tmp3_ = g_strdup ("ftp");
	_tmp4_ = g_strdup ("mms");
	_tmp5_ = g_new0 (gchar*, 5 + 1);
	_tmp5_[0] = _tmp0_;
	_tmp5_[1] = _tmp1_;
	_tmp5_[2] = _tmp2_;
	_tmp5_[3] = _tmp3_;
	_tmp5_[4] = _tmp4_;
	sa = _tmp5_;
	sa_length1 = 5;
	_sa_size_ = sa_length1;
	_tmp6_ = sa;
	_tmp6__length1 = sa_length1;
	if (result_length1) {
		*result_length1 = _tmp6__length1;
	}
	result = _tmp6_;
	return result;
}


gchar** mpris_root_get_SupportedMimeTypes (MprisRoot* self, int* result_length1) {
	gchar** result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar** _tmp45_ = NULL;
	gchar** sa;
	gint sa_length1;
	gint _sa_size_;
	gchar** _tmp46_;
	gint _tmp46__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("application/x-ogg");
	_tmp1_ = g_strdup ("application/ogg");
	_tmp2_ = g_strdup ("video/3gpp");
	_tmp3_ = g_strdup ("video/avi");
	_tmp4_ = g_strdup ("video/dv");
	_tmp5_ = g_strdup ("video/fli");
	_tmp6_ = g_strdup ("video/flv");
	_tmp7_ = g_strdup ("video/mp4");
	_tmp8_ = g_strdup ("video/mp4v-es");
	_tmp9_ = g_strdup ("video/mpeg");
	_tmp10_ = g_strdup ("video/msvideo");
	_tmp11_ = g_strdup ("video/ogg");
	_tmp12_ = g_strdup ("video/quicktime");
	_tmp13_ = g_strdup ("video/vivo");
	_tmp14_ = g_strdup ("video/vnd.divx");
	_tmp15_ = g_strdup ("video/vnd.vivo");
	_tmp16_ = g_strdup ("video/x-anim");
	_tmp17_ = g_strdup ("video/x-avi");
	_tmp18_ = g_strdup ("video/x-flc");
	_tmp19_ = g_strdup ("video/x-fli");
	_tmp20_ = g_strdup ("video/x-flic");
	_tmp21_ = g_strdup ("video/x-flv");
	_tmp22_ = g_strdup ("video/x-m4v");
	_tmp23_ = g_strdup ("video/x-matroska");
	_tmp24_ = g_strdup ("video/x-mpeg");
	_tmp25_ = g_strdup ("video/x-mpg");
	_tmp26_ = g_strdup ("video/x-ms-asf");
	_tmp27_ = g_strdup ("video/x-msvideo");
	_tmp28_ = g_strdup ("video/x-ms-wm");
	_tmp29_ = g_strdup ("video/x-ms-wmv");
	_tmp30_ = g_strdup ("video/x-ms-wmx");
	_tmp31_ = g_strdup ("video/x-ms-wvx");
	_tmp32_ = g_strdup ("video/x-nsv");
	_tmp33_ = g_strdup ("video/x-ogm+ogg");
	_tmp34_ = g_strdup ("video/x-theora");
	_tmp35_ = g_strdup ("video/x-theora+ogg");
	_tmp36_ = g_strdup ("audio/x-vorbis+ogg");
	_tmp37_ = g_strdup ("audio/x-scpls");
	_tmp38_ = g_strdup ("audio/x-mp3");
	_tmp39_ = g_strdup ("audio/x-mpeg");
	_tmp40_ = g_strdup ("audio/mpeg");
	_tmp41_ = g_strdup ("audio/x-mpegurl");
	_tmp42_ = g_strdup ("audio/x-flac");
	_tmp43_ = g_strdup ("x-content/audio-cdda");
	_tmp44_ = g_strdup ("x-content/audio-player");
	_tmp45_ = g_new0 (gchar*, 45 + 1);
	_tmp45_[0] = _tmp0_;
	_tmp45_[1] = _tmp1_;
	_tmp45_[2] = _tmp2_;
	_tmp45_[3] = _tmp3_;
	_tmp45_[4] = _tmp4_;
	_tmp45_[5] = _tmp5_;
	_tmp45_[6] = _tmp6_;
	_tmp45_[7] = _tmp7_;
	_tmp45_[8] = _tmp8_;
	_tmp45_[9] = _tmp9_;
	_tmp45_[10] = _tmp10_;
	_tmp45_[11] = _tmp11_;
	_tmp45_[12] = _tmp12_;
	_tmp45_[13] = _tmp13_;
	_tmp45_[14] = _tmp14_;
	_tmp45_[15] = _tmp15_;
	_tmp45_[16] = _tmp16_;
	_tmp45_[17] = _tmp17_;
	_tmp45_[18] = _tmp18_;
	_tmp45_[19] = _tmp19_;
	_tmp45_[20] = _tmp20_;
	_tmp45_[21] = _tmp21_;
	_tmp45_[22] = _tmp22_;
	_tmp45_[23] = _tmp23_;
	_tmp45_[24] = _tmp24_;
	_tmp45_[25] = _tmp25_;
	_tmp45_[26] = _tmp26_;
	_tmp45_[27] = _tmp27_;
	_tmp45_[28] = _tmp28_;
	_tmp45_[29] = _tmp29_;
	_tmp45_[30] = _tmp30_;
	_tmp45_[31] = _tmp31_;
	_tmp45_[32] = _tmp32_;
	_tmp45_[33] = _tmp33_;
	_tmp45_[34] = _tmp34_;
	_tmp45_[35] = _tmp35_;
	_tmp45_[36] = _tmp36_;
	_tmp45_[37] = _tmp37_;
	_tmp45_[38] = _tmp38_;
	_tmp45_[39] = _tmp39_;
	_tmp45_[40] = _tmp40_;
	_tmp45_[41] = _tmp41_;
	_tmp45_[42] = _tmp42_;
	_tmp45_[43] = _tmp43_;
	_tmp45_[44] = _tmp44_;
	sa = _tmp45_;
	sa_length1 = 45;
	_sa_size_ = sa_length1;
	_tmp46_ = sa;
	_tmp46__length1 = sa_length1;
	if (result_length1) {
		*result_length1 = _tmp46__length1;
	}
	result = _tmp46_;
	return result;
}


static void mpris_root_class_init (MprisRootClass * klass) {
	mpris_root_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisRootPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_root_get_property;
	G_OBJECT_CLASS (klass)->finalize = mpris_root_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_QUIT, g_param_spec_boolean ("CanQuit", "CanQuit", "CanQuit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_RAISE, g_param_spec_boolean ("CanRaise", "CanRaise", "CanRaise", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_HAS_TRACK_LIST, g_param_spec_boolean ("HasTrackList", "HasTrackList", "HasTrackList", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_DESKTOP_ENTRY, g_param_spec_string ("DesktopEntry", "DesktopEntry", "DesktopEntry", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_IDENTITY, g_param_spec_string ("Identity", "Identity", "Identity", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_URI_SCHEMES, g_param_spec_boxed ("SupportedUriSchemes", "SupportedUriSchemes", "SupportedUriSchemes", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_MIME_TYPES, g_param_spec_boxed ("SupportedMimeTypes", "SupportedMimeTypes", "SupportedMimeTypes", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void mpris_root_instance_init (MprisRoot * self) {
	self->priv = MPRIS_ROOT_GET_PRIVATE (self);
}


static void mpris_root_finalize (GObject* obj) {
	MprisRoot * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_ROOT, MprisRoot);
	G_OBJECT_CLASS (mpris_root_parent_class)->finalize (obj);
}


GType mpris_root_get_type (void) {
	return mpris_root_type_id;
}


GType mpris_root_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisRoot), 0, (GInstanceInitFunc) mpris_root_instance_init, NULL };
	mpris_root_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisRoot", &g_define_type_info, 0);
	g_type_set_qdata (mpris_root_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_root_register_object);
	return mpris_root_type_id;
}


static void _vala_mpris_root_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MprisRoot * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_ROOT, MprisRoot);
	switch (property_id) {
		case MPRIS_ROOT_CAN_QUIT:
		g_value_set_boolean (value, mpris_root_get_CanQuit (self));
		break;
		case MPRIS_ROOT_CAN_RAISE:
		g_value_set_boolean (value, mpris_root_get_CanRaise (self));
		break;
		case MPRIS_ROOT_HAS_TRACK_LIST:
		g_value_set_boolean (value, mpris_root_get_HasTrackList (self));
		break;
		case MPRIS_ROOT_DESKTOP_ENTRY:
		g_value_take_string (value, mpris_root_get_DesktopEntry (self));
		break;
		case MPRIS_ROOT_IDENTITY:
		g_value_take_string (value, mpris_root_get_Identity (self));
		break;
		case MPRIS_ROOT_SUPPORTED_URI_SCHEMES:
		{
			int length;
			g_value_take_boxed (value, mpris_root_get_SupportedUriSchemes (self, &length));
		}
		break;
		case MPRIS_ROOT_SUPPORTED_MIME_TYPES:
		{
			int length;
			g_value_take_boxed (value, mpris_root_get_SupportedMimeTypes (self, &length));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_mpris_root_Quit (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_root_Quit (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_root_Raise (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_root_Raise (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_root_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Quit") == 0) {
		_dbus_mpris_root_Quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Raise") == 0) {
		_dbus_mpris_root_Raise (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_mpris_root_get_CanQuit (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_CanQuit (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_CanRaise (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_CanRaise (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_HasTrackList (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_HasTrackList (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_DesktopEntry (MprisRoot* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_root_get_DesktopEntry (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_Identity (MprisRoot* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_root_get_Identity (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_SupportedUriSchemes (MprisRoot* self) {
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp0_;
	GVariantBuilder _tmp1_;
	int _tmp2_;
	GVariant* _reply;
	result = mpris_root_get_SupportedUriSchemes (self, &result_length1);
	_tmp0_ = result;
	g_variant_builder_init (&_tmp1_, G_VARIANT_TYPE ("as"));
	for (_tmp2_ = 0; _tmp2_ < result_length1; _tmp2_++) {
		g_variant_builder_add_value (&_tmp1_, g_variant_new_string (*_tmp0_));
		_tmp0_++;
	}
	_reply = g_variant_builder_end (&_tmp1_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_SupportedMimeTypes (MprisRoot* self) {
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp3_;
	GVariantBuilder _tmp4_;
	int _tmp5_;
	GVariant* _reply;
	result = mpris_root_get_SupportedMimeTypes (self, &result_length1);
	_tmp3_ = result;
	g_variant_builder_init (&_tmp4_, G_VARIANT_TYPE ("as"));
	for (_tmp5_ = 0; _tmp5_ < result_length1; _tmp5_++) {
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string (*_tmp3_));
		_tmp3_++;
	}
	_reply = g_variant_builder_end (&_tmp4_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "CanQuit") == 0) {
		return _dbus_mpris_root_get_CanQuit (object);
	} else if (strcmp (property_name, "CanRaise") == 0) {
		return _dbus_mpris_root_get_CanRaise (object);
	} else if (strcmp (property_name, "HasTrackList") == 0) {
		return _dbus_mpris_root_get_HasTrackList (object);
	} else if (strcmp (property_name, "DesktopEntry") == 0) {
		return _dbus_mpris_root_get_DesktopEntry (object);
	} else if (strcmp (property_name, "Identity") == 0) {
		return _dbus_mpris_root_get_Identity (object);
	} else if (strcmp (property_name, "SupportedUriSchemes") == 0) {
		return _dbus_mpris_root_get_SupportedUriSchemes (object);
	} else if (strcmp (property_name, "SupportedMimeTypes") == 0) {
		return _dbus_mpris_root_get_SupportedMimeTypes (object);
	}
	return NULL;
}


static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint mpris_root_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_root_dbus_interface_info), &_mpris_root_dbus_interface_vtable, data, _mpris_root_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _mpris_root_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static GType mpris_player_direction_get_type (void) {
	static volatile gsize mpris_player_direction_type_id__volatile = 0;
	if (g_once_init_enter (&mpris_player_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{MPRIS_PLAYER_DIRECTION_NEXT, "MPRIS_PLAYER_DIRECTION_NEXT", "next"}, {MPRIS_PLAYER_DIRECTION_PREVIOUS, "MPRIS_PLAYER_DIRECTION_PREVIOUS", "previous"}, {MPRIS_PLAYER_DIRECTION_STOP, "MPRIS_PLAYER_DIRECTION_STOP", "stop"}, {0, NULL, NULL}};
		GType mpris_player_direction_type_id;
		mpris_player_direction_type_id = g_enum_register_static ("MprisPlayerDirection", values);
		g_once_init_leave (&mpris_player_direction_type_id__volatile, mpris_player_direction_type_id);
	}
	return mpris_player_direction_type_id__volatile;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_variant_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}


static GVariant* _variant_new1 (gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void __lambda2_ (MprisPlayer* self, GObject* s, GParamSpec* p) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* variant;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = mpris_player_get_PlaybackStatus (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = _variant_new1 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	variant = _tmp4_;
	mpris_player_queue_property_for_notification (self, "PlaybackStatus", variant);
	_g_variant_unref0 (variant);
}


static void ___lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda2_ (self, _sender, pspec);
}


static void _mpris_player_on_tag_changed_xnoise_global_access_tag_changed (XnoiseGlobalAccess* _sender, const gchar* newuri, const gchar* tagname, const gchar* tagvalue, gpointer self) {
	mpris_player_on_tag_changed (self, _sender, newuri, tagname, tagvalue);
}


static GVariant* _variant_new2 (gdouble value) {
	return g_variant_ref_sink (g_variant_new_double (value));
}


static void __lambda4_ (MprisPlayer* self) {
	XnoiseGstPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GVariant* _tmp3_;
	GVariant* variant;
	_tmp0_ = xnoise_gst_player;
	_tmp1_ = xnoise_gst_player_get_volume (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _variant_new2 (_tmp2_);
	variant = _tmp3_;
	mpris_player_queue_property_for_notification (self, "Volume", variant);
	_g_variant_unref0 (variant);
}


static void ___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda4_ (self);
}


static GVariant* _variant_new3 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new4 (gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new5 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void __lambda5_ (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* s;
	const gchar* _tmp4_;
	_tmp0_ = xnoise_global;
	_tmp1_ = xnoise_global_access_get_image_path_large (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	s = _tmp3_;
	_tmp4_ = s;
	if (_tmp4_ == NULL) {
		GHashTable* _tmp5_;
		gchar* _tmp6_;
		GVariant* _tmp7_;
		_tmp5_ = self->priv->_metadata;
		_tmp6_ = g_strdup ("mpris:artUrl");
		_tmp7_ = _variant_new3 (XNOISE_RESOURCES_EMPTYSTRING);
		g_hash_table_insert (_tmp5_, _tmp6_, _tmp7_);
	} else {
		const gchar* _tmp8_;
		GFile* _tmp9_ = NULL;
		GFile* f;
		GFile* _tmp10_;
		_tmp8_ = s;
		_tmp9_ = g_file_new_for_commandline_arg (_tmp8_);
		f = _tmp9_;
		_tmp10_ = f;
		if (_tmp10_ != NULL) {
			GHashTable* _tmp11_;
			gchar* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			GVariant* _tmp16_;
			_tmp11_ = self->priv->_metadata;
			_tmp12_ = g_strdup ("mpris:artUrl");
			_tmp13_ = f;
			_tmp14_ = g_file_get_uri (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = _variant_new4 (_tmp15_);
			g_hash_table_insert (_tmp11_, _tmp12_, _tmp16_);
			_g_free0 (_tmp15_);
		} else {
			GHashTable* _tmp17_;
			gchar* _tmp18_;
			GVariant* _tmp19_;
			_tmp17_ = self->priv->_metadata;
			_tmp18_ = g_strdup ("mpris:artUrl");
			_tmp19_ = _variant_new5 (XNOISE_RESOURCES_EMPTYSTRING);
			g_hash_table_insert (_tmp17_, _tmp18_, _tmp19_);
		}
		_g_object_unref0 (f);
	}
	mpris_player_trigger_metadata_update (self);
	_g_free0 (s);
}


static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda5_ (self);
}


static GVariant* _variant_new6 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static gint64 _variant_get7 (GVariant* value) {
	return g_variant_get_int64 (value);
}


static GVariant* _variant_new8 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static void __lambda6_ (MprisPlayer* self) {
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	XnoiseGstPlayer* _tmp10_;
	gint64 _tmp11_;
	gint64 _tmp12_;
	gint64 length_val;
	GHashTable* _tmp13_;
	gconstpointer _tmp14_ = NULL;
	gint64 _tmp15_;
	gint64 _tmp16_;
	_tmp0_ = self->priv->_metadata;
	_tmp1_ = g_hash_table_lookup (_tmp0_, "mpris:length");
	if (((GVariant*) _tmp1_) == NULL) {
		XnoiseGstPlayer* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		gint64 u_sec;
		gint64 _tmp5_;
		_tmp2_ = xnoise_gst_player;
		_tmp3_ = xnoise_gst_player_get_length_nsecs (_tmp2_);
		_tmp4_ = _tmp3_;
		u_sec = _tmp4_ / 1000;
		_tmp5_ = u_sec;
		if (_tmp5_ > ((gint64) 0)) {
			GHashTable* _tmp6_;
			gchar* _tmp7_;
			gint64 _tmp8_;
			GVariant* _tmp9_;
			_tmp6_ = self->priv->_metadata;
			_tmp7_ = g_strdup ("mpris:length");
			_tmp8_ = u_sec;
			_tmp9_ = _variant_new6 (_tmp8_);
			g_hash_table_insert (_tmp6_, _tmp7_, _tmp9_);
			mpris_player_trigger_metadata_update (self);
		}
		return;
	}
	_tmp10_ = xnoise_gst_player;
	_tmp11_ = xnoise_gst_player_get_length_nsecs (_tmp10_);
	_tmp12_ = _tmp11_;
	length_val = (gint64) (_tmp12_ / ((gint64) 1000));
	_tmp13_ = self->priv->_metadata;
	_tmp14_ = g_hash_table_lookup (_tmp13_, "mpris:length");
	_tmp15_ = _variant_get7 ((GVariant*) _tmp14_);
	_tmp16_ = length_val;
	if (_tmp15_ != _tmp16_) {
		XnoiseGstPlayer* _tmp17_;
		gint64 _tmp18_;
		gint64 _tmp19_;
		gint64 u_sec;
		gint64 _tmp20_;
		_tmp17_ = xnoise_gst_player;
		_tmp18_ = xnoise_gst_player_get_length_nsecs (_tmp17_);
		_tmp19_ = _tmp18_;
		u_sec = _tmp19_ / 1000;
		_tmp20_ = u_sec;
		if (_tmp20_ > ((gint64) 0)) {
			GHashTable* _tmp21_;
			gchar* _tmp22_;
			gint64 _tmp23_;
			GVariant* _tmp24_;
			_tmp21_ = self->priv->_metadata;
			_tmp22_ = g_strdup ("mpris:length");
			_tmp23_ = u_sec;
			_tmp24_ = _variant_new8 (_tmp23_);
			g_hash_table_insert (_tmp21_, _tmp22_, _tmp24_);
			mpris_player_trigger_metadata_update (self);
		}
	}
}


static void ___lambda6__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda6_ (self);
}


static void __lambda7_ (MprisPlayer* self, XnoiseGstPlayer* g, guint p, guint s) {
	guint _tmp0_;
	gint64 x;
	g_return_if_fail (g != NULL);
	_tmp0_ = p;
	x = ((gint64) _tmp0_) * 1000;
	g_signal_emit_by_name (self, "seeked", x);
}


static void ___lambda7__xnoise_gst_player_sign_position_changed (XnoiseGstPlayer* _sender, guint msecs, guint ms_total, gpointer self) {
	__lambda7_ (self, _sender, msecs, ms_total);
}


MprisPlayer* mpris_player_construct (GType object_type, GDBusConnection* conn) {
	MprisPlayer * self = NULL;
	GDBusConnection* _tmp0_;
	XnoiseMain* _tmp1_;
	XnoiseMain* _tmp2_;
	XnoiseGlobalAccess* _tmp3_;
	XnoiseGlobalAccess* _tmp4_;
	XnoiseGstPlayer* _tmp5_;
	XnoiseGlobalAccess* _tmp6_;
	XnoiseGstPlayer* _tmp7_;
	XnoiseGstPlayer* _tmp8_;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (MprisPlayer*) g_object_new (object_type, NULL);
	_tmp0_ = conn;
	self->priv->conn = _tmp0_;
	_tmp1_ = xnoise_main_get_instance ();
	_tmp2_ = _tmp1_;
	self->priv->xn = _tmp2_;
	_tmp3_ = xnoise_global;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::player-state", (GCallback) ___lambda2__g_object_notify, self, 0);
	_tmp4_ = xnoise_global;
	g_signal_connect_object (_tmp4_, "tag-changed", (GCallback) _mpris_player_on_tag_changed_xnoise_global_access_tag_changed, self, 0);
	_tmp5_ = xnoise_gst_player;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::volume", (GCallback) ___lambda4__g_object_notify, self, 0);
	_tmp6_ = xnoise_global;
	g_signal_connect_object ((GObject*) _tmp6_, "notify::image-path-large", (GCallback) ___lambda5__g_object_notify, self, 0);
	_tmp7_ = xnoise_gst_player;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::length-nsecs", (GCallback) ___lambda6__g_object_notify, self, 0);
	_tmp8_ = xnoise_gst_player;
	g_signal_connect_object (_tmp8_, "sign-position-changed", (GCallback) ___lambda7__xnoise_gst_player_sign_position_changed, self, 0);
	self->priv->_CanSeek = TRUE;
	return self;
}


MprisPlayer* mpris_player_new (GDBusConnection* conn) {
	return mpris_player_construct (TYPE_MPRIS_PLAYER, conn);
}


static GVariant* _variant_new9 (GHashTable* value) {
	GVariantBuilder _tmp1_;
	GHashTableIter _tmp2_;
	gpointer _tmp3_;
	gpointer _tmp4_;
	g_hash_table_iter_init (&_tmp2_, value);
	g_variant_builder_init (&_tmp1_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp2_, &_tmp3_, &_tmp4_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp3_;
		_value = (GVariant*) _tmp4_;
		g_variant_builder_add (&_tmp1_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp1_));
}


static gboolean __lambda3_ (MprisPlayer* self) {
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	GVariant* _tmp5_;
	GVariant* variant;
	_tmp0_ = self->priv->_metadata;
	_tmp5_ = _variant_new9 (_tmp0_);
	variant = _tmp5_;
	mpris_player_queue_property_for_notification (self, "Metadata", variant);
	self->priv->update_metadata_source = (guint) 0;
	result = FALSE;
	_g_variant_unref0 (variant);
	return result;
}


static gboolean ___lambda3__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda3_ (self);
	return result;
}


static void mpris_player_trigger_metadata_update (MprisPlayer* self) {
	guint _tmp0_;
	guint _tmp2_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->update_metadata_source;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->update_metadata_source;
		g_source_remove (_tmp1_);
	}
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, ___lambda3__gsource_func, g_object_ref (self), g_object_unref);
	self->priv->update_metadata_source = _tmp2_;
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GVariant* _variant_new10 (gchar** value, gint value_length1) {
	gchar** _tmp12_;
	GVariantBuilder _tmp13_;
	int _tmp14_;
	_tmp12_ = value;
	g_variant_builder_init (&_tmp13_, G_VARIANT_TYPE ("as"));
	for (_tmp14_ = 0; _tmp14_ < value_length1; _tmp14_++) {
		g_variant_builder_add_value (&_tmp13_, g_variant_new_string (*_tmp12_));
		_tmp12_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp13_));
}


static GVariant* _variant_new11 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new12 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GVariant* _variant_new13 (gchar** value, gint value_length1) {
	gchar** _tmp38_;
	GVariantBuilder _tmp39_;
	int _tmp40_;
	_tmp38_ = value;
	g_variant_builder_init (&_tmp39_, G_VARIANT_TYPE ("as"));
	for (_tmp40_ = 0; _tmp40_ < value_length1; _tmp40_++) {
		g_variant_builder_add_value (&_tmp39_, g_variant_new_string (*_tmp38_));
		_tmp38_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp39_));
}


static void mpris_player_on_tag_changed (MprisPlayer* self, XnoiseGlobalAccess* sender, const gchar* newuri, const gchar* tagname, const gchar* tagvalue) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	_tmp0_ = tagname;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("artist")))) {
		switch (0) {
			default:
			{
				gchar** _tmp4_ = NULL;
				gchar** sa;
				gint sa_length1;
				gint _sa_size_;
				const gchar* _tmp5_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				GHashTable* _tmp9_;
				gchar* _tmp10_;
				gchar** _tmp11_;
				gint _tmp11__length1;
				GVariant* _tmp15_;
				_tmp4_ = g_new0 (gchar*, 0 + 1);
				sa = _tmp4_;
				sa_length1 = 0;
				_sa_size_ = sa_length1;
				_tmp5_ = tagvalue;
				if (_tmp5_ == NULL) {
					tagvalue = XNOISE_RESOURCES_EMPTYSTRING;
				}
				_tmp6_ = sa;
				_tmp6__length1 = sa_length1;
				_tmp7_ = tagvalue;
				_tmp8_ = g_strdup (_tmp7_);
				_vala_array_add1 (&sa, &sa_length1, &_sa_size_, _tmp8_);
				_tmp9_ = self->priv->_metadata;
				_tmp10_ = g_strdup ("xesam:artist");
				_tmp11_ = sa;
				_tmp11__length1 = sa_length1;
				_tmp15_ = _variant_new10 (_tmp11_, _tmp11__length1);
				g_hash_table_insert (_tmp9_, _tmp10_, _tmp15_);
				sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("album")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* s;
				GHashTable* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
				GVariant* _tmp22_;
				_tmp16_ = tagvalue;
				if (_tmp16_ == NULL) {
					tagvalue = XNOISE_RESOURCES_EMPTYSTRING;
				}
				_tmp17_ = tagvalue;
				_tmp18_ = g_strdup (_tmp17_);
				s = _tmp18_;
				_tmp19_ = self->priv->_metadata;
				_tmp20_ = g_strdup ("xesam:album");
				_tmp21_ = s;
				_tmp22_ = _variant_new11 (_tmp21_);
				g_hash_table_insert (_tmp19_, _tmp20_, _tmp22_);
				_g_free0 (s);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("title")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* s;
				GHashTable* _tmp26_;
				gchar* _tmp27_;
				const gchar* _tmp28_;
				GVariant* _tmp29_;
				_tmp23_ = tagvalue;
				if (_tmp23_ == NULL) {
					tagvalue = XNOISE_RESOURCES_EMPTYSTRING;
				}
				_tmp24_ = tagvalue;
				_tmp25_ = g_strdup (_tmp24_);
				s = _tmp25_;
				_tmp26_ = self->priv->_metadata;
				_tmp27_ = g_strdup ("xesam:title");
				_tmp28_ = s;
				_tmp29_ = _variant_new12 (_tmp28_);
				g_hash_table_insert (_tmp26_, _tmp27_, _tmp29_);
				_g_free0 (s);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("genre")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp30_;
				gchar** _tmp31_ = NULL;
				gchar** sa;
				gint sa_length1;
				gint _sa_size_;
				gchar** _tmp32_;
				gint _tmp32__length1;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				GHashTable* _tmp35_;
				gchar* _tmp36_;
				gchar** _tmp37_;
				gint _tmp37__length1;
				GVariant* _tmp41_;
				_tmp30_ = tagvalue;
				if (_tmp30_ == NULL) {
					tagvalue = XNOISE_RESOURCES_EMPTYSTRING;
				}
				_tmp31_ = g_new0 (gchar*, 0 + 1);
				sa = _tmp31_;
				sa_length1 = 0;
				_sa_size_ = sa_length1;
				_tmp32_ = sa;
				_tmp32__length1 = sa_length1;
				_tmp33_ = tagvalue;
				_tmp34_ = g_strdup (_tmp33_);
				_vala_array_add2 (&sa, &sa_length1, &_sa_size_, _tmp34_);
				_tmp35_ = self->priv->_metadata;
				_tmp36_ = g_strdup ("xesam:genre");
				_tmp37_ = sa;
				_tmp37__length1 = sa_length1;
				_tmp41_ = _variant_new13 (_tmp37_, _tmp37__length1);
				g_hash_table_insert (_tmp35_, _tmp36_, _tmp41_);
				sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				return;
			}
		}
	}
	mpris_player_trigger_metadata_update (self);
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static gboolean mpris_player_send_property_change (MprisPlayer* self) {
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	const GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* builder;
	GVariantType* _tmp3_;
	GVariantType* _tmp4_;
	GVariantBuilder* _tmp5_;
	GVariantBuilder* _tmp6_;
	GVariantBuilder* invalidated_builder;
	GHashTable* _tmp7_;
	GList* _tmp8_ = NULL;
	GVariant* _tmp17_;
	GVariantBuilder* _tmp18_;
	GVariant* _tmp19_ = NULL;
	GVariantBuilder* _tmp20_;
	GVariant* _tmp21_ = NULL;
	GVariant** _tmp22_ = NULL;
	GVariant** arg_tuple;
	gint arg_tuple_length1;
	gint _arg_tuple_size_;
	GVariant** _tmp23_;
	gint _tmp23__length1;
	GVariant* _tmp24_;
	GVariant* args;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->changed_properties;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = G_VARIANT_TYPE_DICTIONARY;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	builder = _tmp2_;
	_tmp3_ = g_variant_type_new ("as");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_variant_builder_new (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_variant_type_free0 (_tmp4_);
	invalidated_builder = _tmp6_;
	_tmp7_ = self->priv->changed_properties;
	_tmp8_ = g_hash_table_get_keys (_tmp7_);
	{
		GList* name_collection = NULL;
		GList* name_it = NULL;
		name_collection = _tmp8_;
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
			gchar* _tmp9_;
			gchar* name = NULL;
			_tmp9_ = g_strdup ((const gchar*) name_it->data);
			name = _tmp9_;
			{
				GHashTable* _tmp10_;
				const gchar* _tmp11_;
				gconstpointer _tmp12_ = NULL;
				GVariant* _tmp13_;
				GVariant* variant;
				GVariantBuilder* _tmp14_;
				const gchar* _tmp15_;
				GVariant* _tmp16_;
				_tmp10_ = self->priv->changed_properties;
				_tmp11_ = name;
				_tmp12_ = g_hash_table_lookup (_tmp10_, _tmp11_);
				_tmp13_ = _g_variant_ref0 ((GVariant*) _tmp12_);
				variant = _tmp13_;
				_tmp14_ = builder;
				_tmp15_ = name;
				_tmp16_ = variant;
				g_variant_builder_add (_tmp14_, "{sv}", _tmp15_, _tmp16_, NULL);
				_g_variant_unref0 (variant);
				_g_free0 (name);
			}
		}
		_g_list_free0 (name_collection);
	}
	_g_hash_table_unref0 (self->priv->changed_properties);
	self->priv->changed_properties = NULL;
	_tmp17_ = g_variant_new ("s", MPRIS_PLAYER_INTERFACE_NAME, NULL);
	g_variant_ref_sink (_tmp17_);
	_tmp18_ = builder;
	_tmp19_ = g_variant_builder_end (_tmp18_);
	g_variant_ref_sink (_tmp19_);
	_tmp20_ = invalidated_builder;
	_tmp21_ = g_variant_builder_end (_tmp20_);
	g_variant_ref_sink (_tmp21_);
	_tmp22_ = g_new0 (GVariant*, 3 + 1);
	_tmp22_[0] = _tmp17_;
	_tmp22_[1] = _tmp19_;
	_tmp22_[2] = _tmp21_;
	arg_tuple = _tmp22_;
	arg_tuple_length1 = 3;
	_arg_tuple_size_ = arg_tuple_length1;
	_tmp23_ = arg_tuple;
	_tmp23__length1 = arg_tuple_length1;
	_tmp24_ = g_variant_new_tuple (_tmp23_, _tmp23__length1);
	g_variant_ref_sink (_tmp24_);
	args = _tmp24_;
	{
		GDBusConnection* _tmp25_;
		GVariant* _tmp26_;
		_tmp25_ = self->priv->conn;
		_tmp26_ = args;
		g_dbus_connection_emit_signal (_tmp25_, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", _tmp26_, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp27_ = e;
		_tmp28_ = _tmp27_->message;
		g_print ("Error emmitting PropertiesChanged dbus signal: %s\n", _tmp28_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_variant_unref0 (args);
		arg_tuple = (_vala_array_free (arg_tuple, arg_tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
		_g_variant_builder_unref0 (invalidated_builder);
		_g_variant_builder_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	self->priv->send_property_source = (guint) 0;
	result = FALSE;
	_g_variant_unref0 (args);
	arg_tuple = (_vala_array_free (arg_tuple, arg_tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
	_g_variant_builder_unref0 (invalidated_builder);
	_g_variant_builder_unref0 (builder);
	return result;
}


static gboolean _mpris_player_send_property_change_gsource_func (gpointer self) {
	gboolean result;
	result = mpris_player_send_property_change (self);
	return result;
}


static void mpris_player_queue_property_for_notification (MprisPlayer* self, const gchar* property, GVariant* val) {
	GHashTable* _tmp0_;
	GHashTable* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	guint _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = self->priv->changed_properties;
	if (_tmp0_ == NULL) {
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		_tmp1_ = g_str_hash;
		_tmp2_ = g_str_equal;
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_variant_unref0_);
		_g_hash_table_unref0 (self->priv->changed_properties);
		self->priv->changed_properties = _tmp3_;
	}
	_tmp4_ = self->priv->changed_properties;
	_tmp5_ = property;
	_tmp6_ = g_strdup (_tmp5_);
	_tmp7_ = val;
	_tmp8_ = _g_variant_ref0 (_tmp7_);
	g_hash_table_insert (_tmp4_, _tmp6_, _tmp8_);
	_tmp9_ = self->priv->send_property_source;
	if (_tmp9_ == ((guint) 0)) {
		guint _tmp10_ = 0U;
		_tmp10_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _mpris_player_send_property_change_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->send_property_source = _tmp10_;
	}
}


void mpris_player_Next (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_global;
	xnoise_global_access_next (_tmp0_);
}


void mpris_player_Previous (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_global;
	xnoise_global_access_prev (_tmp0_);
}


void mpris_player_Pause (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_global;
	xnoise_global_access_pause (_tmp0_);
}


void mpris_player_PlayPause (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_global;
	xnoise_global_access_play (_tmp0_, TRUE);
}


void mpris_player_Stop (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_global;
	xnoise_global_access_stop (_tmp0_);
}


void mpris_player_Play (MprisPlayer* self) {
	XnoiseGlobalAccess* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = xnoise_global;
	xnoise_global_access_play (_tmp0_, FALSE);
}


static gboolean __lambda8_ (MprisPlayer* self) {
	gboolean result = FALSE;
	gint64 micro;
	gboolean _tmp0_ = FALSE;
	XnoiseGstPlayer* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gboolean _tmp8_;
	gint64 _tmp9_;
	gint64 _tmp10_;
	micro = (gint64) 0;
	_tmp1_ = xnoise_gst_player;
	_tmp2_ = xnoise_gst_player_get_abs_position_microseconds (_tmp1_);
	_tmp3_ = _tmp2_;
	micro = _tmp3_;
	_tmp4_ = micro;
	if (_tmp4_ == ((gint64) (-1))) {
		XnoiseGlobalAccess* _tmp5_;
		XnoisePlayerState _tmp6_;
		XnoisePlayerState _tmp7_;
		_tmp5_ = xnoise_global;
		_tmp6_ = xnoise_global_access_get_player_state (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = _tmp7_ == XNOISE_PLAYER_STATE_PLAYING;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp8_ = _tmp0_;
	if (_tmp8_) {
		result = TRUE;
		return result;
	}
	_tmp9_ = micro;
	g_print ("SEEK gst_player.abs_position_microseconds : %lld\n", _tmp9_);
	_tmp10_ = micro;
	g_signal_emit_by_name (self, "seeked", _tmp10_);
	result = FALSE;
	return result;
}


static gboolean ___lambda8__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda8_ (self);
	return result;
}


void mpris_player_Seek (MprisPlayer* self, gint64 offset) {
	XnoiseGstPlayer* _tmp0_;
	gint64 _tmp1_;
	g_return_if_fail (self != NULL);
	g_print ("seek\n");
	_tmp0_ = xnoise_gst_player;
	_tmp1_ = offset;
	xnoise_gst_player_request_micro_time_offset (_tmp0_, _tmp1_);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, g_object_ref (self), g_object_unref);
	return;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		MprisPlayer * self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean __lambda10_ (Block1Data* _data1_) {
	MprisPlayer * self;
	gboolean result = FALSE;
	gint64 _tmp0_;
	self = _data1_->self;
	_tmp0_ = _data1_->Position;
	g_signal_emit_by_name (self, "seeked", _tmp0_);
	result = FALSE;
	return result;
}


static gboolean ___lambda10__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda10_ (self);
	return result;
}


static gboolean __lambda9_ (Block1Data* _data1_) {
	MprisPlayer * self;
	gboolean result = FALSE;
	gint64 micro;
	gboolean _tmp0_ = FALSE;
	XnoiseGstPlayer* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gboolean _tmp8_;
	gint64 _tmp9_;
	self = _data1_->self;
	micro = (gint64) 0;
	_tmp1_ = xnoise_gst_player;
	_tmp2_ = xnoise_gst_player_get_abs_position_microseconds (_tmp1_);
	_tmp3_ = _tmp2_;
	micro = _tmp3_;
	_tmp4_ = micro;
	if (_tmp4_ == ((gint64) (-1))) {
		XnoiseGlobalAccess* _tmp5_;
		XnoisePlayerState _tmp6_;
		XnoisePlayerState _tmp7_;
		_tmp5_ = xnoise_global;
		_tmp6_ = xnoise_global_access_get_player_state (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = _tmp7_ == XNOISE_PLAYER_STATE_PLAYING;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp8_ = _tmp0_;
	if (_tmp8_) {
		result = TRUE;
		return result;
	}
	_tmp9_ = micro;
	g_print ("SET POSITION gst_player.abs_position_microseconds : %lld\n", _tmp9_);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda10__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	result = FALSE;
	return result;
}


static gboolean ___lambda9__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda9_ (self);
	return result;
}


void mpris_player_SetPosition (MprisPlayer* self, const char* TrackId, gint64 Position) {
	Block1Data* _data1_;
	gint64 _tmp0_;
	XnoiseGstPlayer* _tmp1_;
	gint64 _tmp2_;
	XnoiseGstPlayer* _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (TrackId != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = Position;
	_data1_->Position = _tmp0_;
	_tmp1_ = xnoise_gst_player;
	_tmp2_ = _data1_->Position;
	_tmp3_ = xnoise_gst_player;
	_tmp4_ = xnoise_gst_player_get_length_nsecs (_tmp3_);
	_tmp5_ = _tmp4_;
	xnoise_gst_player_set_position (_tmp1_, ((gdouble) _tmp2_) / (_tmp5_ / 1000.0));
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


void mpris_player_OpenUri (MprisPlayer* self, const gchar* Uri) {
	const gchar* _tmp0_;
	XnoiseMain* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (Uri != NULL);
	_tmp0_ = Uri;
	g_print ("OpenUri %s\n", _tmp0_);
	_tmp1_ = self->priv->xn;
	_tmp2_ = Uri;
	xnoise_main_immediate_play (_tmp1_, _tmp2_);
}


gchar* mpris_player_get_PlaybackStatus (MprisPlayer* self) {
	gchar* result;
	XnoiseGlobalAccess* _tmp0_;
	XnoisePlayerState _tmp1_;
	XnoisePlayerState _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xnoise_global;
	_tmp1_ = xnoise_global_access_get_player_state (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case XNOISE_PLAYER_STATE_STOPPED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Stopped");
			result = _tmp3_;
			return result;
		}
		case XNOISE_PLAYER_STATE_PLAYING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Playing");
			result = _tmp4_;
			return result;
		}
		case XNOISE_PLAYER_STATE_PAUSED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("Paused");
			result = _tmp5_;
			return result;
		}
		default:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("Stopped");
			result = _tmp6_;
			return result;
		}
	}
}


gchar* mpris_player_get_LoopStatus (MprisPlayer* self) {
	gchar* result;
	XnoiseMainWindow* _tmp0_;
	XnoiseMainWindowPlayerRepeatMode _tmp1_;
	XnoiseMainWindowPlayerRepeatMode _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xnoise_main_window;
	_tmp1_ = xnoise_main_window_get_repeatState (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_NOT_AT_ALL:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("None");
			result = _tmp3_;
			return result;
		}
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_SINGLE:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Track");
			result = _tmp4_;
			return result;
		}
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_ALL:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("Playlist");
			result = _tmp5_;
			return result;
		}
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_RANDOM:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("Playlist");
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("Playlist");
			result = _tmp7_;
			return result;
		}
	}
}


static GVariant* _variant_new14 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


void mpris_player_set_LoopStatus (MprisPlayer* self, const gchar* value) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	const gchar* _tmp8_;
	GVariant* _tmp9_;
	GVariant* variant;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("None")))) {
		switch (0) {
			default:
			{
				XnoiseMainWindow* _tmp4_;
				_tmp4_ = xnoise_main_window;
				xnoise_main_window_set_repeatState (_tmp4_, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_NOT_AT_ALL);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("Track")))) {
		switch (0) {
			default:
			{
				XnoiseMainWindow* _tmp5_;
				_tmp5_ = xnoise_main_window;
				xnoise_main_window_set_repeatState (_tmp5_, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_SINGLE);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("Playlist")))) {
		switch (0) {
			default:
			{
				XnoiseMainWindow* _tmp6_;
				_tmp6_ = xnoise_main_window;
				xnoise_main_window_set_repeatState (_tmp6_, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_ALL);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				XnoiseMainWindow* _tmp7_;
				_tmp7_ = xnoise_main_window;
				xnoise_main_window_set_repeatState (_tmp7_, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_ALL);
				break;
			}
		}
	}
	_tmp8_ = value;
	_tmp9_ = _variant_new14 (_tmp8_);
	variant = _tmp9_;
	mpris_player_queue_property_for_notification (self, "LoopStatus", variant);
	_g_variant_unref0 (variant);
	g_object_notify ((GObject *) self, "LoopStatus");
}


gdouble mpris_player_get_Rate (MprisPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


void mpris_player_set_Rate (MprisPlayer* self, gdouble value) {
	g_return_if_fail (self != NULL);
	g_object_notify ((GObject *) self, "Rate");
}


gboolean mpris_player_get_Shuffle (MprisPlayer* self) {
	gboolean result;
	XnoiseMainWindow* _tmp0_;
	XnoiseMainWindowPlayerRepeatMode _tmp1_;
	XnoiseMainWindowPlayerRepeatMode _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = xnoise_main_window;
	_tmp1_ = xnoise_main_window_get_repeatState (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_RANDOM) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static GVariant* _variant_new15 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void mpris_player_set_Shuffle (MprisPlayer* self, gboolean value) {
	gboolean _tmp0_;
	gboolean _tmp7_;
	GVariant* _tmp8_;
	GVariant* variant;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_ == TRUE) {
		XnoiseMainWindow* _tmp1_;
		XnoiseMainWindowPlayerRepeatMode _tmp2_;
		XnoiseMainWindowPlayerRepeatMode _tmp3_;
		XnoiseMainWindow* _tmp4_;
		_tmp1_ = xnoise_main_window;
		_tmp2_ = xnoise_main_window_get_repeatState (_tmp1_);
		_tmp3_ = _tmp2_;
		self->priv->buffer_repeat_state = _tmp3_;
		_tmp4_ = xnoise_main_window;
		xnoise_main_window_set_repeatState (_tmp4_, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_RANDOM);
	} else {
		XnoiseMainWindow* _tmp5_;
		XnoiseMainWindowPlayerRepeatMode _tmp6_;
		_tmp5_ = xnoise_main_window;
		_tmp6_ = self->priv->buffer_repeat_state;
		xnoise_main_window_set_repeatState (_tmp5_, _tmp6_);
	}
	_tmp7_ = value;
	_tmp8_ = _variant_new15 (_tmp7_);
	variant = _tmp8_;
	mpris_player_queue_property_for_notification (self, "Shuffle", variant);
	_g_variant_unref0 (variant);
	g_object_notify ((GObject *) self, "Shuffle");
}


static GVariant* _variant_new16 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* mpris_player_get_Metadata (MprisPlayer* self) {
	GHashTable* result;
	GVariant* _tmp0_;
	GVariant* variant;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	GVariant* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = _variant_new16 ("/");
	variant = _tmp0_;
	_tmp1_ = self->priv->_metadata;
	_tmp2_ = g_strdup ("mpris:trackid");
	_tmp3_ = _g_variant_ref0 (variant);
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
	_tmp4_ = self->priv->_metadata;
	_tmp5_ = _g_hash_table_ref0 (_tmp4_);
	result = _tmp5_;
	_g_variant_unref0 (variant);
	return result;
}


gdouble mpris_player_get_Volume (MprisPlayer* self) {
	gdouble result;
	XnoiseGstPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = xnoise_gst_player;
	_tmp1_ = xnoise_gst_player_get_volume (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void mpris_player_set_Volume (MprisPlayer* self, gdouble value) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	XnoiseGstPlayer* _tmp2_;
	gdouble _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_ < 0.0) {
		value = 0.0;
	}
	_tmp1_ = value;
	if (_tmp1_ > 1.0) {
		value = 1.0;
	}
	_tmp2_ = xnoise_gst_player;
	_tmp3_ = value;
	xnoise_gst_player_set_volume (_tmp2_, _tmp3_);
	g_object_notify ((GObject *) self, "Volume");
}


gint64 mpris_player_get_Position (MprisPlayer* self) {
	gint64 result;
	XnoiseGstPlayer* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	XnoiseGstPlayer* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble pos;
	gdouble _tmp6_;
	XnoiseGstPlayer* _tmp7_;
	gint64 _tmp8_;
	gint64 _tmp9_;
	g_return_val_if_fail (self != NULL, 0LL);
	g_print ("get position property\n");
	_tmp0_ = xnoise_gst_player;
	_tmp1_ = xnoise_gst_player_get_length_nsecs (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == ((gint64) 0)) {
		result = (gint64) 0;
		return result;
	}
	_tmp3_ = xnoise_gst_player;
	_tmp4_ = xnoise_gst_player_get_position (_tmp3_);
	_tmp5_ = _tmp4_;
	pos = _tmp5_;
	_tmp6_ = pos;
	_tmp7_ = xnoise_gst_player;
	_tmp8_ = xnoise_gst_player_get_length_nsecs (_tmp7_);
	_tmp9_ = _tmp8_;
	result = (gint64) ((_tmp6_ * _tmp9_) / 1000.0);
	return result;
}


gdouble mpris_player_get_MinimumRate (MprisPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gdouble mpris_player_get_MaximumRate (MprisPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gboolean mpris_player_get_CanGoNext (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanGoPrevious (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanPlay (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanPause (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanSeek (MprisPlayer* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_CanSeek;
	result = _tmp0_;
	return result;
}


gboolean mpris_player_get_CanControl (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}


static void mpris_player_class_init (MprisPlayerClass * klass) {
	mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisPlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mpris_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = mpris_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_PLAYBACK_STATUS, g_param_spec_string ("PlaybackStatus", "PlaybackStatus", "PlaybackStatus", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_LOOP_STATUS, g_param_spec_string ("LoopStatus", "LoopStatus", "LoopStatus", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_RATE, g_param_spec_double ("Rate", "Rate", "Rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_SHUFFLE, g_param_spec_boolean ("Shuffle", "Shuffle", "Shuffle", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_METADATA, g_param_spec_boxed ("Metadata", "Metadata", "Metadata", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_VOLUME, g_param_spec_double ("Volume", "Volume", "Volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_POSITION, g_param_spec_int64 ("Position", "Position", "Position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_MINIMUM_RATE, g_param_spec_double ("MinimumRate", "MinimumRate", "MinimumRate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_MAXIMUM_RATE, g_param_spec_double ("MaximumRate", "MaximumRate", "MaximumRate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_NEXT, g_param_spec_boolean ("CanGoNext", "CanGoNext", "CanGoNext", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_PREVIOUS, g_param_spec_boolean ("CanGoPrevious", "CanGoPrevious", "CanGoPrevious", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PLAY, g_param_spec_boolean ("CanPlay", "CanPlay", "CanPlay", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PAUSE, g_param_spec_boolean ("CanPause", "CanPause", "CanPause", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_SEEK, g_param_spec_boolean ("CanSeek", "CanSeek", "CanSeek", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_CONTROL, g_param_spec_boolean ("CanControl", "CanControl", "CanControl", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("seeked", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
}


static void mpris_player_instance_init (MprisPlayer * self) {
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	self->priv = MPRIS_PLAYER_GET_PRIVATE (self);
	self->priv->send_property_source = (guint) 0;
	self->priv->update_metadata_source = (guint) 0;
	self->priv->changed_properties = NULL;
	self->priv->buffer_repeat_state = XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_NOT_AT_ALL;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_variant_unref0_);
	self->priv->_metadata = _tmp2_;
	self->priv->_CanSeek = TRUE;
}


static void mpris_player_finalize (GObject* obj) {
	MprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_PLAYER, MprisPlayer);
	_g_hash_table_unref0 (self->priv->changed_properties);
	_g_hash_table_unref0 (self->priv->_metadata);
	G_OBJECT_CLASS (mpris_player_parent_class)->finalize (obj);
}


GType mpris_player_get_type (void) {
	return mpris_player_type_id;
}


GType mpris_player_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisPlayer), 0, (GInstanceInitFunc) mpris_player_instance_init, NULL };
	mpris_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisPlayer", &g_define_type_info, 0);
	g_type_set_qdata (mpris_player_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_player_register_object);
	return mpris_player_type_id;
}


static void _vala_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_PLAYER, MprisPlayer);
	switch (property_id) {
		case MPRIS_PLAYER_PLAYBACK_STATUS:
		g_value_take_string (value, mpris_player_get_PlaybackStatus (self));
		break;
		case MPRIS_PLAYER_LOOP_STATUS:
		g_value_take_string (value, mpris_player_get_LoopStatus (self));
		break;
		case MPRIS_PLAYER_RATE:
		g_value_set_double (value, mpris_player_get_Rate (self));
		break;
		case MPRIS_PLAYER_SHUFFLE:
		g_value_set_boolean (value, mpris_player_get_Shuffle (self));
		break;
		case MPRIS_PLAYER_METADATA:
		g_value_take_boxed (value, mpris_player_get_Metadata (self));
		break;
		case MPRIS_PLAYER_VOLUME:
		g_value_set_double (value, mpris_player_get_Volume (self));
		break;
		case MPRIS_PLAYER_POSITION:
		g_value_set_int64 (value, mpris_player_get_Position (self));
		break;
		case MPRIS_PLAYER_MINIMUM_RATE:
		g_value_set_double (value, mpris_player_get_MinimumRate (self));
		break;
		case MPRIS_PLAYER_MAXIMUM_RATE:
		g_value_set_double (value, mpris_player_get_MaximumRate (self));
		break;
		case MPRIS_PLAYER_CAN_GO_NEXT:
		g_value_set_boolean (value, mpris_player_get_CanGoNext (self));
		break;
		case MPRIS_PLAYER_CAN_GO_PREVIOUS:
		g_value_set_boolean (value, mpris_player_get_CanGoPrevious (self));
		break;
		case MPRIS_PLAYER_CAN_PLAY:
		g_value_set_boolean (value, mpris_player_get_CanPlay (self));
		break;
		case MPRIS_PLAYER_CAN_PAUSE:
		g_value_set_boolean (value, mpris_player_get_CanPause (self));
		break;
		case MPRIS_PLAYER_CAN_SEEK:
		g_value_set_boolean (value, mpris_player_get_CanSeek (self));
		break;
		case MPRIS_PLAYER_CAN_CONTROL:
		g_value_set_boolean (value, mpris_player_get_CanControl (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_PLAYER, MprisPlayer);
	switch (property_id) {
		case MPRIS_PLAYER_LOOP_STATUS:
		mpris_player_set_LoopStatus (self, g_value_get_string (value));
		break;
		case MPRIS_PLAYER_RATE:
		mpris_player_set_Rate (self, g_value_get_double (value));
		break;
		case MPRIS_PLAYER_SHUFFLE:
		mpris_player_set_Shuffle (self, g_value_get_boolean (value));
		break;
		case MPRIS_PLAYER_VOLUME:
		mpris_player_set_Volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_mpris_player_Next (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Next (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Previous (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Previous (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Pause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Pause (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_PlayPause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_PlayPause (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Stop (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Stop (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Play (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Play (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Seek (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint64 offset = 0LL;
	GVariant* _tmp6_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_int64 (_tmp6_);
	g_variant_unref (_tmp6_);
	mpris_player_Seek (self, offset);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_SetPosition (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* TrackId = NULL;
	GVariant* _tmp7_;
	gint64 Position = 0LL;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	TrackId = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	Position = g_variant_get_int64 (_tmp8_);
	g_variant_unref (_tmp8_);
	mpris_player_SetPosition (self, TrackId, Position);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (TrackId);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_OpenUri (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* Uri = NULL;
	GVariant* _tmp9_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	Uri = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	mpris_player_OpenUri (self, Uri);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (Uri);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_mpris_player_Next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_mpris_player_Previous (object, parameters, invocation);
	} else if (strcmp (method_name, "Pause") == 0) {
		_dbus_mpris_player_Pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_mpris_player_PlayPause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_mpris_player_Stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_mpris_player_Play (object, parameters, invocation);
	} else if (strcmp (method_name, "Seek") == 0) {
		_dbus_mpris_player_Seek (object, parameters, invocation);
	} else if (strcmp (method_name, "SetPosition") == 0) {
		_dbus_mpris_player_SetPosition (object, parameters, invocation);
	} else if (strcmp (method_name, "OpenUri") == 0) {
		_dbus_mpris_player_OpenUri (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_mpris_player_get_PlaybackStatus (MprisPlayer* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_PlaybackStatus (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_LoopStatus (MprisPlayer* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_LoopStatus (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Rate (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_Rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Shuffle (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_Shuffle (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Metadata (MprisPlayer* self) {
	GHashTable* result;
	GVariantBuilder _tmp10_;
	GHashTableIter _tmp11_;
	gpointer _tmp12_;
	gpointer _tmp13_;
	GVariant* _reply;
	result = mpris_player_get_Metadata (self);
	g_hash_table_iter_init (&_tmp11_, result);
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp11_, &_tmp12_, &_tmp13_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp12_;
		_value = (GVariant*) _tmp13_;
		g_variant_builder_add (&_tmp10_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp10_);
	_g_hash_table_unref0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Volume (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_Volume (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Position (MprisPlayer* self) {
	gint64 result;
	GVariant* _reply;
	result = mpris_player_get_Position (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_MinimumRate (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_MinimumRate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_MaximumRate (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_MaximumRate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanGoNext (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanGoNext (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanGoPrevious (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanGoPrevious (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanPlay (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanPlay (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanPause (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanPause (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanSeek (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanSeek (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanControl (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanControl (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_mpris_player_get_PlaybackStatus (object);
	} else if (strcmp (property_name, "LoopStatus") == 0) {
		return _dbus_mpris_player_get_LoopStatus (object);
	} else if (strcmp (property_name, "Rate") == 0) {
		return _dbus_mpris_player_get_Rate (object);
	} else if (strcmp (property_name, "Shuffle") == 0) {
		return _dbus_mpris_player_get_Shuffle (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_mpris_player_get_Metadata (object);
	} else if (strcmp (property_name, "Volume") == 0) {
		return _dbus_mpris_player_get_Volume (object);
	} else if (strcmp (property_name, "Position") == 0) {
		return _dbus_mpris_player_get_Position (object);
	} else if (strcmp (property_name, "MinimumRate") == 0) {
		return _dbus_mpris_player_get_MinimumRate (object);
	} else if (strcmp (property_name, "MaximumRate") == 0) {
		return _dbus_mpris_player_get_MaximumRate (object);
	} else if (strcmp (property_name, "CanGoNext") == 0) {
		return _dbus_mpris_player_get_CanGoNext (object);
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		return _dbus_mpris_player_get_CanGoPrevious (object);
	} else if (strcmp (property_name, "CanPlay") == 0) {
		return _dbus_mpris_player_get_CanPlay (object);
	} else if (strcmp (property_name, "CanPause") == 0) {
		return _dbus_mpris_player_get_CanPause (object);
	} else if (strcmp (property_name, "CanSeek") == 0) {
		return _dbus_mpris_player_get_CanSeek (object);
	} else if (strcmp (property_name, "CanControl") == 0) {
		return _dbus_mpris_player_get_CanControl (object);
	}
	return NULL;
}


static void _dbus_mpris_player_set_LoopStatus (MprisPlayer* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	mpris_player_set_LoopStatus (self, value);
	_g_free0 (value);
}


static void _dbus_mpris_player_set_Rate (MprisPlayer* self, GVariant* _value) {
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_Rate (self, value);
}


static void _dbus_mpris_player_set_Shuffle (MprisPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	mpris_player_set_Shuffle (self, value);
}


static void _dbus_mpris_player_set_Volume (MprisPlayer* self, GVariant* _value) {
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_Volume (self, value);
}


static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "LoopStatus") == 0) {
		_dbus_mpris_player_set_LoopStatus (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Rate") == 0) {
		_dbus_mpris_player_set_Rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Shuffle") == 0) {
		_dbus_mpris_player_set_Shuffle (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Volume") == 0) {
		_dbus_mpris_player_set_Volume (object, value);
		return TRUE;
	}
	return FALSE;
}


static void _dbus_mpris_player_seeked (GObject* _sender, gint64 Position, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int64 (Position));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Player", "Seeked", _arguments, NULL);
}


guint mpris_player_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_player_dbus_interface_info), &_mpris_player_dbus_interface_vtable, data, _mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "seeked", (GCallback) _dbus_mpris_player_seeked, data);
	return result;
}


static void _mpris_player_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_mpris_player_seeked, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


MprisTrackList* mpris_track_list_construct (GType object_type, GDBusConnection* conn) {
	MprisTrackList * self = NULL;
	GDBusConnection* _tmp0_;
	XnoiseMain* _tmp1_;
	XnoiseMain* _tmp2_;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (MprisTrackList*) g_object_new (object_type, NULL);
	_tmp0_ = conn;
	self->priv->conn = _tmp0_;
	_tmp1_ = xnoise_main_get_instance ();
	_tmp2_ = _tmp1_;
	self->priv->xn = _tmp2_;
	return self;
}


MprisTrackList* mpris_track_list_new (GDBusConnection* conn) {
	return mpris_track_list_construct (TYPE_MPRIS_TRACK_LIST, conn);
}


GHashTable* mpris_track_list_GetTracksMetadata (MprisTrackList* self, gint Position) {
	GHashTable* result = NULL;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = Position;
	g_print ("GetTracksMetadata %d\n", _tmp0_);
	result = NULL;
	return result;
}


gint mpris_track_list_AddTrack (MprisTrackList* self, const gchar* Uri, gboolean PlayImmediately) {
	gint result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (Uri != NULL, 0);
	_tmp0_ = Uri;
	_tmp1_ = PlayImmediately;
	g_print ("AddTrack %s %b\n", _tmp0_, _tmp1_);
	result = 0;
	return result;
}


gint mpris_track_list_GetCurrentTrack (MprisTrackList* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_print ("GetCurrentTrack\n");
	result = 0;
	return result;
}


gint mpris_track_list_GetLength (MprisTrackList* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_print ("GetLength\n");
	result = 0;
	return result;
}


void mpris_track_list_DelTrack (MprisTrackList* self, gint Position) {
	g_return_if_fail (self != NULL);
	g_print ("DelTrack\n");
}


void mpris_track_list_SetLoop (MprisTrackList* self, gboolean State) {
	g_return_if_fail (self != NULL);
	g_print ("SetLoop\n");
}


void mpris_track_list_SetRandom (MprisTrackList* self, gboolean State) {
	g_return_if_fail (self != NULL);
	g_print ("SetRandom\n");
}


static void mpris_track_list_class_init (MprisTrackListClass * klass) {
	mpris_track_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisTrackListPrivate));
	G_OBJECT_CLASS (klass)->finalize = mpris_track_list_finalize;
	g_signal_new ("track_list_change", TYPE_MPRIS_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}


static void mpris_track_list_instance_init (MprisTrackList * self) {
	self->priv = MPRIS_TRACK_LIST_GET_PRIVATE (self);
}


static void mpris_track_list_finalize (GObject* obj) {
	MprisTrackList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_TRACK_LIST, MprisTrackList);
	G_OBJECT_CLASS (mpris_track_list_parent_class)->finalize (obj);
}


GType mpris_track_list_get_type (void) {
	return mpris_track_list_type_id;
}


GType mpris_track_list_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisTrackListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_track_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisTrackList), 0, (GInstanceInitFunc) mpris_track_list_instance_init, NULL };
	mpris_track_list_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisTrackList", &g_define_type_info, 0);
	g_type_set_qdata (mpris_track_list_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_track_list_register_object);
	return mpris_track_list_type_id;
}


static void _dbus_mpris_track_list_GetTracksMetadata (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint Position = 0;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp15_;
	GHashTableIter _tmp16_;
	gpointer _tmp17_;
	gpointer _tmp18_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	Position = g_variant_get_int32 (_tmp14_);
	g_variant_unref (_tmp14_);
	result = mpris_track_list_GetTracksMetadata (self, Position);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp16_, result);
	g_variant_builder_init (&_tmp15_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp16_, &_tmp17_, &_tmp18_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp17_;
		_value = (GVariant*) _tmp18_;
		g_variant_builder_add (&_tmp15_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp15_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_track_list_AddTrack (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* Uri = NULL;
	GVariant* _tmp19_;
	gboolean PlayImmediately = FALSE;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint result;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	Uri = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	PlayImmediately = g_variant_get_boolean (_tmp20_);
	g_variant_unref (_tmp20_);
	result = mpris_track_list_AddTrack (self, Uri, PlayImmediately);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (Uri);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_track_list_GetCurrentTrack (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = mpris_track_list_GetCurrentTrack (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_track_list_GetLength (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = mpris_track_list_GetLength (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_track_list_DelTrack (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint Position = 0;
	GVariant* _tmp21_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	Position = g_variant_get_int32 (_tmp21_);
	g_variant_unref (_tmp21_);
	mpris_track_list_DelTrack (self, Position);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_track_list_SetLoop (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean State = FALSE;
	GVariant* _tmp22_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp22_ = g_variant_iter_next_value (&_arguments_iter);
	State = g_variant_get_boolean (_tmp22_);
	g_variant_unref (_tmp22_);
	mpris_track_list_SetLoop (self, State);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_track_list_SetRandom (MprisTrackList* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean State = FALSE;
	GVariant* _tmp23_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp23_ = g_variant_iter_next_value (&_arguments_iter);
	State = g_variant_get_boolean (_tmp23_);
	g_variant_unref (_tmp23_);
	mpris_track_list_SetRandom (self, State);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_track_list_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetTracksMetadata") == 0) {
		_dbus_mpris_track_list_GetTracksMetadata (object, parameters, invocation);
	} else if (strcmp (method_name, "AddTrack") == 0) {
		_dbus_mpris_track_list_AddTrack (object, parameters, invocation);
	} else if (strcmp (method_name, "GetCurrentTrack") == 0) {
		_dbus_mpris_track_list_GetCurrentTrack (object, parameters, invocation);
	} else if (strcmp (method_name, "GetLength") == 0) {
		_dbus_mpris_track_list_GetLength (object, parameters, invocation);
	} else if (strcmp (method_name, "DelTrack") == 0) {
		_dbus_mpris_track_list_DelTrack (object, parameters, invocation);
	} else if (strcmp (method_name, "SetLoop") == 0) {
		_dbus_mpris_track_list_SetLoop (object, parameters, invocation);
	} else if (strcmp (method_name, "SetRandom") == 0) {
		_dbus_mpris_track_list_SetRandom (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* mpris_track_list_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean mpris_track_list_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_mpris_track_list_track_list_change (GObject* _sender, gint Nb_Tracks, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (Nb_Tracks));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Tracklist", "TrackListChange", _arguments, NULL);
}


guint mpris_track_list_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_track_list_dbus_interface_info), &_mpris_track_list_dbus_interface_vtable, data, _mpris_track_list_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "track-list-change", (GCallback) _dbus_mpris_track_list_track_list_change, data);
	return result;
}


static void _mpris_track_list_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_mpris_track_list_track_list_change, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



